#!/bin/bash

MKIMAGE=${CRISP_RELEASE}/tools/bin/mkimage
if [ -z "$KERNEL_IMAGE" ]; then
	KERNEL_IMAGE=$CNC_PLATFORM/images/uImage
fi

if [ -z "$JFFS2_IMAGE" ]; then
	JFFS2_IMAGE=$CNC_PLATFORM/imageutils/rootfs.nand.jffs2_for_cnc_largepage
fi

cp $KERNEL_IMAGE ./
cp $JFFS2_IMAGE ./rootfs

IMGNAME="misc.img"
echo "**** $IMGNAME"

ramdisk_name="rootfs"
touch misc.bin
if 
test -f large_su-boot.bin
then
mkimage -n 'U-boot' -A arm -O linux -T firmware -C none -d large_su-boot.bin large_su-boot.img
cat large_su-boot.img >> misc.bin
rm -f large_su-boot.img
fi

if
test -f uImage
then
cat uImage >> misc.bin
fi

if
test -f $ramdisk_name
then
mkimage -n 'Ramdisk' -A arm -O linux -T ramdisk -C none -d $ramdisk_name {$ramdisk_name}.img
cat {$ramdisk_name}.img >> misc.bin
rm -f {$ramdisk_name}.img
fi

if test -s misc.bin
then
mkimage -n 'Misc image' -A arm -O linux -T firmware -C none -d misc.bin misc.temp
rm -f misc.bin
else
rm -f misc.bin
echo "no valid files available to generate a image!"
echo
exit
fi

if
test -f encrypt.c
then
gcc encrypt.c
echo
echo "Start encrypting!"
./a.out
if [ "$IMGNAME" != "misc.img" ]; then
	mv misc.img $IMGNAME
fi
echo "Encrypting finished!"
echo
rm -f misc.temp a.out rootfs uImage $JFFS2_IMAGE
else
mv misc.temp $IMGNAME
echo "The image file is generated but not encrypted!"
fi
