#!/bin/bash

echo "PROJECT HOME is ${ROOTFS}"
if [ -z ${ROOTFS} ]; then
	ROOTFS=../target
fi
echo "PROJECT HOME is ${ROOTFS}"

ROOTFS_TARGET=${ROOTFS}
FIRMWARE_SRC=${CRISP_RELEASE}/firmware
FIRMWARE_DES=$ROOTFS_TARGET/lib/firmware
SUMTOOL=${CRISP_RELEASE}/tools/bin/sumtool
JFFS2_BIN=${CRISP_RELEASE}/tools/bin/mkfs.jffs2
FILENAME_ORG=rootfs.nand.jffs2

FW_DIR=`ls ${FIRMWARE_SRC} ` 
generate_rootfs()
{
    echo 'generating jffs2 filesystem for NAND Flash'
    echo 'JFFS2 for NAND is depend on the type of NAND, the command is special for HYNIX HYUF081G2A (erase block size: 128KB; page size:2KB)'
    $JFFS2_BIN -U -p -d $ROOTFS_TARGET -n --eraseblock=$ERASEBLOCK_NAND_LARGEPAGE --pagesize=$PAGESIZE_NAND_LARGEPAGE  -o ${FILENAME}_temp
    if test -f ${FILENAME}_temp;then
	$SUMTOOL --eraseblock=$ERASEBLOCK_NAND_LARGEPAGE  -i ${FILENAME}_temp -o ${FILENAME}_largepage
	rm -f ${FILENAME}_temp
    else
	echo 'error !!!'
	exit
    fi
}

if test -d $ROOTFS_TARGET; then
    echo "found rootfs ${ROOTFS_TARGET}"
    if test ! -d $FIRMWARE_DES; then
        mkdir $FIRMWARE_DES
    fi

    if test -d $FIRMWARE_SRC && test -d $FIRMWARE_DES; then
        echo "Generating for cnc"
        cp -f $FIRMWARE_SRC/* $FIRMWARE_DES
        FILENAME=${FILENAME_ORG}_for_cnc
        ERASEBLOCK_NAND_LARGEPAGE="0x20000"
        PAGESIZE_NAND_LARGEPAGE="0x800"
        ERASEBLOCK_NAND_SMALLPAGE="0x4000"
        PAGESIZE_NAND_SMALLPAGE="0x200"
        generate_rootfs
    else
	echo "Cannot found $FIRMWARE_SRC or $FIRMWARE_DES"
    fi
else
	echo "Cannot found rootfs ${ROOTFS_TARGET}"
fi

