#!/bin/bash

ROOTFS=$1
OUTPUT_FILE_NAME=$2

echo "ROOTFS=${ROOTFS}"
echo "OUTPUT_FILE_NAME=${OUTPUT_FILE_NAME}"

generate_ramdisk()
{
    tmp_ramdisk_file_name=ramdisk.tmp
    tmp_ramdisk_file_name_zip=ramdisk.tmp.gz
    size=`du -s --apparent-size $ROOTFS | cut --fields=1`
    size=`expr '(' '(' $size / 1024 ')' + 2 ')' '*' 1024 `
    if [ $size -ge 20000 ];
    then
		size=$(expr $size + 16384)
    else
		size=$(expr $size + 2400)
    fi    
    echo 'rootfs size='$size
        
    inode_counti=`expr '(' $size / 4 ')'`
    
    ${CRISP_RELEASE}/tools/bin/genext2fs -b $size \
    									-m 0 \
    									-N $inode_counti \
    									-d ${ROOTFS} \
    									${tmp_ramdisk_file_name}
    
    echo 'Compressing .......'    
	# Use best compression for file.
    gzip -v9 ${tmp_ramdisk_file_name}

    echo '*****************************************'
    echo 'Generated - ' ${tmp_ramdisk_file_name_zip}
    echo 'Use this value to specify the Ramdisk size in Board configuration utility'
    echo 'Generated - ramdisk from ' ${tmp_ramdisk_file_name_zip} and output is available @ ${OUTPUT_FILE_NAME}
    echo '*****************************************'
    ${CRISP_RELEASE}/tools/bin/mkimage -A arm -O linux -T ramdisk -C gzip \
    								 -a 0x02500000 -e 0x02500000 \
    								 -n "CNC83xx_${CUSTOMER_NAME}_RAMDisk" \
    								 -d ${tmp_ramdisk_file_name_zip}  ${OUTPUT_FILE_NAME}
    rm *.gz
}

generate_ramdisk;

