#!/bin/bash
# Author: xiaodong.fan@celestialsemi.com
# build for automatic generating of rootfs of different platform

echo "PROJECT HOME is ${CNC_PROJECT_HOME}"
if [ -z ${CNC_PROJECT_HOME} ]; then
        CNC_PROJECT_HOME=..
fi
ROOTFS_TARGET=${CNC_PROJECT_HOME}/target
FIRMWARE_SRC=${CRISP_RELEASE}/firmware
FIRMWARE_DES=$ROOTFS_TARGET/lib/firmware
YAFFS2_BIN=${CRISP_RELEASE}/tools/bin/mkyaffs2image

FILENAME_ORG1=rootfs.yaffs2

FW_DIR=`ls ${FIRMWARE_SRC} ` 
generate_rootfs()
{
    echo 'generating yaffs2 filesystem for large page NAND Flash: page size:2KB+'
    $YAFFS2_BIN  $ROOTFS_TARGET  ${FILENAME1}

}

if test -d $ROOTFS_TARGET; then
	if test ! -d $FIRMWARE_DES; then
		mkdir $FIRMWARE_DES
	fi

    if test -d $FIRMWARE_SRC && test -d $FIRMWARE_DES; then
        #for arg in $FW_DIR 
        #  do
          //echo "Generating for $arg"
          echo "Generating for cnc"
          rm -f $FIRMWARE_DES/*
          cp -f $FIRMWARE_SRC/* $FIRMWARE_DES
          FILENAME1=${FILENAME_ORG1}_for_cnc
		  generate_rootfs
        #done
    else
          FILENAME1=${FILENAME_ORG1}
		  generate_rootfs
    fi

fi

