#############################################################
#
# glmark2
#
#############################################################

GLMARK2_VERSION:=2012.12
GLMARK2_SITE:=https://launchpad.net/glmark2/trunk/2012.12/+download
GLMARK2_SOURCE = glmark2-$(GLMARK2_VERSION).tar.gz
GLMARK2_LICENSE = GPLv3+
GLMARK2_DEPENDENCIES = directfb
GLMARK2_CONF_OPT = \
    --enable-glesv2_dfb_egl

GLMARK2_INSTALL_STAGING = NO
GLMARK2_INSTALL_TARGET = YES

# glmark2 depends on OpenGL-ES and EGL, which are provided by a third-party vendor.
# We do not have their pkg-config files, so we need to specify the dependency directories explicitly.
#
# TODO: We are using a relative path here to reference a directory outside buildroot.
#       We need to reconfirm the correct approach for doing this. 

GLMARK2_VENDOR_L1D1    = ../../../../thirdparty/vivante_2d
GLMARK2_VENDOR_L1D2    = ../../../../thirdparty/vivante_3d
GLMARK2_VENDOR_L2D1    = $(CRISP_RELEASE)/thirdparty/cnc1900/2d
GLMARK2_VENDOR_L2D2    = $(CRISP_RELEASE)/thirdparty/cnc1900/3d

GLMARK2_VENDOR_CFLAGS  =  -I`readlink -f $(GLMARK2_VENDOR_L1D1)/include` -I`readlink -f $(GLMARK2_VENDOR_L1D2)/include`
GLMARK2_VENDOR_CFLAGS  += -I`readlink -f $(GLMARK2_VENDOR_L2D1)/include` -I`readlink -f $(GLMARK2_VENDOR_L2D2)/include`
GLMARK2_VENDOR_LDFLAGS =  -L`readlink -f $(GLMARK2_VENDOR_L1D1)/lib` -L`readlink -f $(GLMARK2_VENDOR_L1D2)/lib`
GLMARK2_VENDOR_LDFLAGS += -L`readlink -f $(GLMARK2_VENDOR_L2D1)/lib` -L`readlink -f $(GLMARK2_VENDOR_L2D2)/lib`
GLMARK2_STAGING_DIRECTORY = `readlink -f "../../staging"`

define GLMARK2_CONFIGURE_CMDS
	(cd "$(@D)"; export PREVIOUS_PKG_CONFIG_PATH="$(PKG_CONFIG_PATH)"; export PKG_CONFIG_PATH="$(@D)/pkgconfig_spoof"; \
    $(TARGET_CONFIGURE_OPTS) \
	CFLAGS="--sysroot=$(STAGING_DIR) $(GLMARK2_VENDOR_CFLAGS) -I$(GLMARK2_STAGING_DIRECTORY)/usr/include -I$(GLMARK2_STAGING_DIRECTORY)/usr/include/directfb" \
	CXXFLAGS="--sysroot=$(STAGING_DIR) $(GLMARK2_VENDOR_CFLAGS) -I$(GLMARK2_STAGING_DIRECTORY)/usr/include -I$(GLMARK2_STAGING_DIRECTORY)/usr/include/directfb" \
	LDFLAGS="-Wl,--sysroot=$(STAGING_DIR) $(GLMARK2_VENDOR_LDFLAGS) -L$(GLMARK2_STAGING_DIRECTORY)/usr/lib" \
	./waf $(GLMARK2_CONF_OPT) --destdir=$(TARGET_DIR) configure; \
	export PKG_CONFIG_PATH="$(PREVIOUS_PKG_CONFIG_PATH)")
endef

define GLMARK2_BUILD_CMDS
	(cd "$(@D)"; \
	./waf --destdir=$(TARGET_DIR))
endef

define GLMARK2_INSTALL_TARGET_CMDS
	(cd "$(@D)"; \
	./waf --destdir=$(TARGET_DIR) install)
endef

$(eval $(generic-package))
