#ifndef __include_mterror_h__
#define __include_mterror_h__

/*
 * BS:
 *----
 * This class defines the various errors that occur during HTTP
 *
 * Functions Used:
 *----------------
 * MtError
 * -> assigns error code if any to the member 'error'
 *
 * Dependency:
 *------------
 * None
 */
class MtError
{
private:
    int error;
public:
    enum ErrorCode
    {
        Ok = 0,
        Error = -1000,
        InvalidState = (Error - 1),
        UnknownScheme = (Error - 2),
        CantConnected = (Error - 3),
        Handshake = (Error - 4),
        Disconnected = (Error - 5),
        ConnectionClosed = (Error - 6),
        NoResource = (Error - 7),
        LoadingCompleted = (Error - 8),
        RedirectCountExceeded = (Error - 9),
        __MaxErrorCode = (Error - 10)
    };
    /*
     * BS:
     * Assigns 0 to the variable 'error' if no error occurs
     */
    MtError (ErrorCode a = Ok) :
        error (a)
    {
    }
    ;
    MtError (int a) :
        error (a)
    {
    }
    ;
    //MtError operator =(ErrorCode a) { error = a; };
    //MtError operator =(int a) { error = a; };
    operator int ()
    {
        return error;
    }
    ;
};

#endif
