/*
 # COPYRIGHT NOTICE
 #
 #***************************************************************************

 The following software code is the property of Cavium, Inc.
 Cavium, Inc. reserves all rights in this software, including but not limited
 to copyright and shall be vested with all rights incidental thereto.

 Rights granted to you by or under any licence shall be limited to those
 explicitly granted. You may not record, store, reproduce, reverse engineer,
 decompile, inter-operate and/or transmit this software in any medium,
 electronic or otherwise, without the express written consent of Cavium, Inc.

 ALL RIGHTS RESERVED.

 Copyright 2013, Cavium, Inc.
 #***************************************************************************
 #
 # END OF COPYRIGHT NOTICE
 #
*/
/**
 * @file cnc_input_keys.h
 * @ingroup core
 * The key codes used in the cncinput
 */
#ifndef __CNC_INPUT_KEYS_H__
#define __CNC_INPUT_KEYS_H__

// This are the keys in the anymote protocol, they could be a good
// start point
// WARNING: if this enum is changed, there is an array in 
// crisp/core/cncsystem/cnc_input_remote.c that should also be updated!!
typedef enum {
    CNC_INPUT_UNKNOWN = 0,
    CNC_INPUT_SOFT_LEFT = 1,
    CNC_INPUT_SOFT_RIGHT = 2,
    CNC_INPUT_HOME = 3,
    CNC_INPUT_BACK = 4,
    CNC_INPUT_CALL = 5,
    CNC_INPUT_0 = 7,
    CNC_INPUT_1 = 8,
    CNC_INPUT_2 = 9,
    CNC_INPUT_3 = 10,
    CNC_INPUT_4 = 11,
    CNC_INPUT_5 = 12,
    CNC_INPUT_6 = 13,
    CNC_INPUT_7 = 14,
    CNC_INPUT_8 = 15,
    CNC_INPUT_9 = 16,
    CNC_INPUT_STAR = 17,
    CNC_INPUT_POUND = 18,
    CNC_INPUT_DPAD_UP = 19,
    CNC_INPUT_DPAD_DOWN = 20,
    CNC_INPUT_DPAD_LEFT = 21,
    CNC_INPUT_DPAD_RIGHT = 22,
    CNC_INPUT_DPAD_CENTER = 23, // CHANGE TO SOMETHING LIKE SELECT OR OK
    CNC_INPUT_VOLUME_UP = 24,
    CNC_INPUT_VOLUME_DOWN = 25,
    CNC_INPUT_POWER = 26,
    CNC_INPUT_CAMERA = 27,
    CNC_INPUT_A = 29,
    CNC_INPUT_B = 30,
    CNC_INPUT_C = 31,
    CNC_INPUT_D = 32,
    CNC_INPUT_E = 33,
    CNC_INPUT_F = 34,
    CNC_INPUT_G = 35,
    CNC_INPUT_H = 36,
    CNC_INPUT_I = 37,
    CNC_INPUT_J = 38,
    CNC_INPUT_K = 39,
    CNC_INPUT_L = 40,
    CNC_INPUT_M = 41,
    CNC_INPUT_N = 42,
    CNC_INPUT_O = 43,
    CNC_INPUT_P = 44,
    CNC_INPUT_Q = 45,
    CNC_INPUT_R = 46,
    CNC_INPUT_S = 47,
    CNC_INPUT_T = 48,
    CNC_INPUT_U = 49,
    CNC_INPUT_V = 50,
    CNC_INPUT_W = 51,
    CNC_INPUT_X = 52,
    CNC_INPUT_Y = 53,
    CNC_INPUT_Z = 54,
    CNC_INPUT_COMMA = 55,
    CNC_INPUT_PERIOD = 56,
    CNC_INPUT_ALT_LEFT = 57,
    CNC_INPUT_ALT_RIGHT = 58,
    CNC_INPUT_SHIFT_LEFT = 59,
    CNC_INPUT_SHIFT_RIGHT = 60,
    CNC_INPUT_TAB = 61,
    CNC_INPUT_SPACE = 62,
    CNC_INPUT_EXPLORER = 64,
    CNC_INPUT_ENTER = 66,
    CNC_INPUT_DEL = 67,
    CNC_INPUT_GRAVE = 68,
    CNC_INPUT_MINUS = 69,
    CNC_INPUT_EQUALS = 70,
    CNC_INPUT_LEFT_BRACKET = 71,
    CNC_INPUT_RIGHT_BRACKET = 72,
    CNC_INPUT_BACKSLASH = 73,
    CNC_INPUT_SEMICOLON = 74,
    CNC_INPUT_APOSTROPHE = 75,
    CNC_INPUT_SLASH = 76,
    CNC_INPUT_AT = 77,
    CNC_INPUT_FOCUS = 80,
    CNC_INPUT_PLUS = 81,
    CNC_INPUT_MENU = 82,
    CNC_INPUT_SEARCH = 84,
    CNC_INPUT_MEDIA_PLAY_PAUSE = 85,
    CNC_INPUT_MEDIA_STOP = 86,
    CNC_INPUT_MEDIA_NEXT = 87,
    CNC_INPUT_MEDIA_PREVIOUS = 88,
    CNC_INPUT_MEDIA_REWIND = 89,
    CNC_INPUT_MEDIA_FAST_FORWARD = 90,
    CNC_INPUT_MUTE = 91,
    CNC_INPUT_CTRL_LEFT = 92,
    CNC_INPUT_CTRL_RIGHT = 93,
    CNC_INPUT_INSERT = 94,
    CNC_INPUT_PAUSE = 95,
    CNC_INPUT_PAGE_UP = 96,
    CNC_INPUT_PAGE_DOWN = 97,
    CNC_INPUT_PRINT_SCREEN = 98,
    CNC_INPUT_INFO = 103,
    CNC_INPUT_WINDOW = 104,
    CNC_INPUT_BOOKMARK = 110,
    CNC_INPUT_CAPS_LOCK = 111,
    CNC_INPUT_ESCAPE = 112,
    CNC_INPUT_META_LEFT = 113,
    CNC_INPUT_META_RIGHT = 114,
    CNC_INPUT_ZOOM_IN = 115,
    CNC_INPUT_ZOOM_OUT = 116,
    CNC_INPUT_CHANNEL_UP = 117,
    CNC_INPUT_CHANNEL_DOWN = 118,
    CNC_INPUT_LIVE = 120,
    CNC_INPUT_DVR = 121,
    CNC_INPUT_GUIDE = 122,
    CNC_INPUT_MEDIA_SKIP_BACK = 123,
    CNC_INPUT_MEDIA_SKIP_FORWARD = 124,
    CNC_INPUT_MEDIA_RECORD = 125,
    CNC_INPUT_MEDIA_PLAY = 126,
    CNC_INPUT_PROG_RED = 128,
    CNC_INPUT_PROG_GREEN = 129,
    CNC_INPUT_PROG_YELLOW = 130,
    CNC_INPUT_PROG_BLUE = 131,
    CNC_INPUT_BD_POWER = 132,
    CNC_INPUT_BD_INPUT = 133,
    CNC_INPUT_STB_POWER = 134,
    CNC_INPUT_STB_INPUT = 135,
    CNC_INPUT_STB_MENU = 136,
    CNC_INPUT_TV_POWER = 137,
    CNC_INPUT_TV_INPUT = 138,
    CNC_INPUT_AVR_POWER = 139,
    CNC_INPUT_AVR_INPUT = 140,
    CNC_INPUT_AUDIO = 141,
    CNC_INPUT_EJECT = 142,
    CNC_INPUT_BD_POPUP_MENU = 143,
    CNC_INPUT_BD_TOP_MENU = 144,
    CNC_INPUT_SETTINGS = 145,
    CNC_INPUT_SETUP = 146,
    CNC_INPUT_MICROPHONE_MUTE = 147,
    CNC_INPUT_PICTSYMBOLS = 148,
    CNC_INPUT_SWITCH_CHARSET = 149,
    CNC_INPUT_FORWARD_DEL = 150,
    CNC_INPUT_SCROLL_LOCK = 151,
    CNC_INPUT_FUNCTION = 152,
    CNC_INPUT_SYSRQ = 153,
    CNC_INPUT_BREAK = 154,
    CNC_INPUT_MOVE_HOME = 155,
    CNC_INPUT_MOVE_END = 156,
    CNC_INPUT_FORWARD = 157,
    CNC_INPUT_MEDIA_CLOSE = 158,
    CNC_INPUT_F1 = 159,
    CNC_INPUT_F2 = 160,
    CNC_INPUT_F3 = 161,
    CNC_INPUT_F4 = 162,
    CNC_INPUT_F5 = 163,
    CNC_INPUT_F6 = 164,
    CNC_INPUT_F7 = 165,
    CNC_INPUT_F8 = 166,
    CNC_INPUT_F9 = 167,
    CNC_INPUT_F10 = 168,
    CNC_INPUT_F11 = 169,
    CNC_INPUT_F12 = 170,
    CNC_INPUT_NUM_LOCK = 171,
    CNC_INPUT_NUMPAD_0 = 172,
    CNC_INPUT_NUMPAD_1 = 173,
    CNC_INPUT_NUMPAD_2 = 174,
    CNC_INPUT_NUMPAD_3 = 175,
    CNC_INPUT_NUMPAD_4 = 176,
    CNC_INPUT_NUMPAD_5 = 177,
    CNC_INPUT_NUMPAD_6 = 178,
    CNC_INPUT_NUMPAD_7 = 179,
    CNC_INPUT_NUMPAD_8 = 180,
    CNC_INPUT_NUMPAD_9 = 181,
    CNC_INPUT_NUMPAD_DIVIDE = 182,
    CNC_INPUT_NUMPAD_MULTIPLY = 183,
    CNC_INPUT_NUMPAD_SUBTRACT = 184,
    CNC_INPUT_NUMPAD_ADD = 185,
    CNC_INPUT_NUMPAD_DOT = 186,
    CNC_INPUT_NUMPAD_COMMA = 187,
    CNC_INPUT_NUMPAD_ENTER = 188,
    CNC_INPUT_NUMPAD_EQUALS = 189,
    CNC_INPUT_NUMPAD_LEFT_PAREN = 190,
    CNC_INPUT_NUMPAD_RIGHT_PAREN = 191,
    CNC_INPUT_APP_SWITCH = 192,
    CNC_INPUT_BTN_FIRST = 256,
    CNC_INPUT_BTN_MISC = 256,
    CNC_INPUT_BTN_0 = 256,
    CNC_INPUT_BTN_1 = 257,
    CNC_INPUT_BTN_2 = 258,
    CNC_INPUT_BTN_3 = 259,
    CNC_INPUT_BTN_4 = 260,
    CNC_INPUT_BTN_5 = 261,
    CNC_INPUT_BTN_6 = 262,
    CNC_INPUT_BTN_7 = 263,
    CNC_INPUT_BTN_8 = 264,
    CNC_INPUT_BTN_9 = 265,
    CNC_INPUT_BTN_MOUSE = 272,
    CNC_INPUT_BTN_LEFT = 272,
    CNC_INPUT_BTN_RIGHT = 273,
    CNC_INPUT_BTN_MIDDLE = 274,
    CNC_INPUT_BTN_SIDE = 275,
    CNC_INPUT_BTN_EXTRA = 276,
    CNC_INPUT_BTN_FORWARD = 277,
    CNC_INPUT_BTN_BACK = 278,
    CNC_INPUT_BTN_TASK = 279,
    CNC_INPUT_BTN_GAME_A = 280,
    CNC_INPUT_BTN_GAME_B = 281,
    CNC_INPUT_BTN_GAME_C = 282,
    CNC_INPUT_BTN_GAME_X = 283,
    CNC_INPUT_BTN_GAME_Y = 284,
    CNC_INPUT_BTN_GAME_Z = 285,
    CNC_INPUT_BTN_GAME_L1 = 286,
    CNC_INPUT_BTN_GAME_R1 = 287,
    CNC_INPUT_BTN_GAME_L2 = 288,
    CNC_INPUT_BTN_GAME_R2 = 289,
    CNC_INPUT_BTN_GAME_THUMBL = 290,
    CNC_INPUT_BTN_GAME_THUMBR = 291,
    CNC_INPUT_BTN_GAME_START = 292,
    CNC_INPUT_BTN_GAME_SELECT = 293,
    CNC_INPUT_BTN_GAME_MODE = 294,
    CNC_INPUT_BTN_GAME_1 = 295,
    CNC_INPUT_BTN_GAME_2 = 296,
    CNC_INPUT_BTN_GAME_3 = 297,
    CNC_INPUT_BTN_GAME_4 = 298,
    CNC_INPUT_BTN_GAME_5 = 299,
    CNC_INPUT_BTN_GAME_6 = 300,
    CNC_INPUT_BTN_GAME_7 = 301,
    CNC_INPUT_BTN_GAME_8 = 302,
    CNC_INPUT_BTN_GAME_9 = 303,
    CNC_INPUT_BTN_GAME_10 = 304,
    CNC_INPUT_BTN_GAME_11 = 305,
    CNC_INPUT_BTN_GAME_12 = 306,
    CNC_INPUT_BTN_GAME_13 = 307,
    CNC_INPUT_BTN_GAME_14 = 308,
    CNC_INPUT_BTN_GAME_15 = 309,
    CNC_INPUT_BTN_GAME_16 = 310,

    CNC_INPUT_EXIT = 311,
    CNC_INPUT_RECALL = 312,
    CNC_INPUT_FAVORITE = 313,
    CNC_INPUT_SUBTITLE = 314,
    CNC_INPUT_ASPECT_RATIO = 315,
    CNC_INPUT_CHANNEL = 316,
    CNC_INPUT_VOD = 317,
    CNC_INPUT_NET = 318,
    CNC_INPUT_HD = 319,
    CNC_INPUT_RADIO = 320,
} cncInputKeyCode_t;
// See warning at the top when adding new elements to cncInputKeyCode_t

#endif // __CNC_INPUT_KEYS_H__
