/*
 # COPYRIGHT NOTICE
 #
 #***************************************************************************

 The following software code is the property of Cavium, Inc.
 Cavium, Inc. reserves all rights in this software, including but not limited
 to copyright and shall be vested with all rights incidental thereto.

 Rights granted to you by or under any licence shall be limited to those
 explicitly granted. You may not record, store, reproduce, reverse engineer,
 decompile, inter-operate and/or transmit this software in any medium,
 electronic or otherwise, without the express written consent of Cavium, Inc.

 ALL RIGHTS RESERVED.

 Copyright 2011-2012, Cavium, Inc.
 #***************************************************************************
 #
 # END OF COPYRIGHT NOTICE
 #
 */

/**
 * @file cnc_xml.h
 * @ingroup core
 * The CNCXML library defines a generic interface for XML parsing and processing
 */
#ifndef _CNC_XML_H_
#define _CNC_XML_H_


#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <libxml/tree.h>

#ifdef __cplusplus
extern "C" {
#endif

int  CNC_XML_OpenFile(char *filename, xmlDocPtr* pXmldoc, xmlNodePtr* pXmlRootNode);
int  CNC_XML_CloseFile(xmlDocPtr pXmldoc);
xmlNodePtr CNC_XML_NodeFilter(xmlNodePtr node,char *keyword) ;
char * CNC_XML_GetNodeName(xmlNodePtr node);
int CNC_XML_CheckNodeName(const char * key, xmlNodePtr curNode);
int CNC_XML_GetChildNodeNum(xmlNodePtr node);
int CNC_XML_GetChildNodeNumWithKey(xmlNodePtr node,char *key);
xmlNodePtr CNC_XML_GotoStr(const char * key, xmlNodePtr curNode);
xmlNodePtr CNC_XML_Enter(xmlNodePtr curNode);
xmlNodePtr CNC_XML_Return(xmlNodePtr curNode);
xmlNodePtr CNC_XML_Rollback(xmlNodePtr curNode);
xmlNodePtr CNC_XML_Next(xmlNodePtr curNode) ;
xmlNodePtr CNC_XML_FindNode(const xmlNodePtr curNode,char * name);
int CNC_XML_GetContent(const xmlNodePtr curNode, char * outbuf, unsigned int outMaxsize);
int CNC_XML_GetNodeAttr(xmlNodePtr curNode, const char * keyword, char * outbuf , unsigned int outMaxsize);
void *CNC_XML_Alloc(int size);
void CNC_XML_Free(void *p);

#ifdef __cplusplus
}
#endif

#endif


