
#ifndef __CSAPI_GLOBAL_H__
#define __CSAPI_GLOBAL_H__

#ifdef __cplusplus
extern "C" {
#endif

#ifdef CONFIG_ANDROID
#define LOG_NDEBUG 0
#define LOG_TAG "CNC"
#include <utils/Log.h>
#ifndef NOLOG
  #define printf(...) ALOGI(__VA_ARGS__)
#else
  #define printf(...)
#endif
#endif

#define UNUSED_VARIABLE(a) do { \
	a = a; \
} while(0);

#define CHECK_HANDLE_VALID(o, m) do { \
	if ((NULL == o) || (o->obj_type != m) ||(o->dev_fd < 0)) { \
        printf("%s Handle ERROR in line %d\n", __FUNCTION__, __LINE__); \
		return CSAPI_FAILED; \
	} \
} while(0)

#define IOCTL(o, cmd, arg, t) do { \
	if (-1 == ioctl(o->dev_fd, cmd, arg)) { \
		o->errnum = t##_ERROR_IOCTL_FAILED; \
		printf("%s IOCTL ERROR in line %d\n", __FUNCTION__, __LINE__); \
		return CSAPI_FAILED; \
	}; \
} while(0)
 
#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif
#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif

typedef enum
{
	CSAPI_SUCCEED = 0,
	CSAPI_FAILED = -1
} CSAPI_RESULT;

#ifdef __cplusplus
}
#endif

#ifndef CONFIG_ANDROID
#define DOLBY_BYPASS
#define USE_GAL_CORE
#endif

#endif  // __CSAPI_GLOBAL_H__
