
/*
 # COPYRIGHT NOTICE
 #
 #***************************************************************************

 The following software code is property of Celestial Systems Inc.
 Celestial Systems Inc. reserves all rights in this software, including but
 not limited to copyright and shall be vested with all rights incidental
 thereto.

 Rights granted to you by or under any license shall be limited to those
 explicitly granted. You may not record, store, reproduce, reverse engineer,
 decompile, inter-operate and/or transmit this software in any medium,
 electronic or otherwise, without the express written consent of Celestial
 Systems Inc.

 ALL RIGHTS RESERVED.

 Copyright 2009-2010, Celestial Systems Inc.
 #***************************************************************************
 #
 # END OF COPYRIGHT NOTICE
 #
 */

/* ============================= File Header ============================== */
/**
 * \brief         Exception handling and back-tracing
 * \file          osal_exceptionTrace.h
 * \author
 * \date          Dec-06-2011
 * \version       0.1
 * \see
 */
/* ======================================================================== */

/* ============================ System Includes =========================== */
#include "cnc_common_typedef.h"
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <sys/times.h>
#include "time.h"
#include <string.h>
#include <stdio.h>


#ifndef _CNC_EXCEPTION_TRACE_H_
#define _CNC_EXCEPTION_TRACE_H_

/* ============================ System Includes =========================== */
// NONE

/* ============================= User Includes ============================ */
// NONE

#ifdef __cplusplus
extern "C"
{
#endif

/* =========================== Macro definitions ========================== */
// NONE

/* =========================== Type definitions =========================== */
// NONE

/* ===================== Global variable declarations ===================== */
// NONE

/* ============== Function declarations =================================== */

void CNC_TRACE_ExceptionInitialize(void);
void CNC_TRACE_ExceptionTerminate(void);
void CNC_Exception_TracePrintStackBacktrace(FILE *file);

#ifdef __cplusplus
}
#endif

#endif /* END: _CNC_EXCEPTION_TRACE_H_ */
