/*
 # COPYRIGHT NOTICE
 #
 #***************************************************************************

 The following software code is the property of Monta-Vista.
 Monta-Vista reserves all rights in this software, including but not limited
 to copyright and shall be vested with all rights incidental thereto.

 Rights granted to you by or under any licence shall be limited to those
 explicitly granted. You may not record, store, reproduce, reverse engineer,
 decompile, inter-operate and/or transmit this software in any medium,
 electronic or otherwise, without the express written consent of Monta-Vista

 ALL RIGHTS RESERVED.

 Copyright 2011-2012, Monta-Vista
 #***************************************************************************
 #
 # END OF COPYRIGHT NOTICE
 #
 */

#ifndef _CNC_TRACEMODULES_H_
#define _CNC_TRACEMODULES_H_

/* ============================ System Includes =========================== */
// NONE


/* ============================= User Includes ============================ */
// NONE


/* =========================== Macro definitions ========================== */
// NONE


#ifdef __cplusplus
extern "C"
{
#endif

/* =========================== Type definitions =========================== */
/* \enum      : cncTraceModules_t
 * \brief     : Module IDs. IDs should be in a sequence 0 to (n-1).
 *              New modules should be added just before CNC_TRACE_NMODULES.
 * \attention : If this list is changed you also need to change g_cncTraceFilter[] and gp_cncModuleNames[] arrays in
                crisp/core/cncutils/cnc_trace.c file
 */
typedef enum cncTraceModulesTag
{
    CNC_TRACE_MODULE_NONE = 0,        	        /*!< Invalid module ID */
    CNC_TRACE_MODULE_TRACE,           	        /*!< ID of the trace module itself */

    /* Module IDs for core */
    CNC_TRACE_MODULE_AV,
    CNC_TRACE_MODULE_SYSTEM,
    CNC_TRACE_MODULE_DEMUX,
    CNC_TRACE_MODULE_FILEMGR,
    CNC_TRACE_MODULE_UTILS,

    /* Module IDs for extension */
    CNC_TRACE_MODULE_MEDIA_CTL,                 /*!< ID of CNC-MEDIA-CTL */
    CNC_TRACE_MODULE_MEDIA_STREAM,              /*!< ID of CNC-MEDIA-STREAM */
    CNC_TRACE_MODULE_MEDIA_DRM,                 /*!< ID of CNC-MEDIA-DRM */
    CNC_TRACE_MODULE_MEDIA_IMAGE,               /*!< ID of CNC-MEDIA-IMAGE */
    CNC_TRACE_MODULE_MEDIA_PLAYER,              /*!< ID of CNC-MEDIA-PLAYER */
    CNC_TRACE_MODULE_MEDIA_SUBTITLE,            /*!< ID of CNC-MEDIA-SUBTITLE */
    CNC_TRACE_MODULE_MEDIA_DECODER,             /*!< ID of CNC-MEDIA-DECODER */
    CNC_TRACE_MODULE_MEDIA_DEMUXER,             /*!< ID of CNC-MEDIA-DEMUXER */
    CNC_TRACE_MODULE_MEDIA_MUXER,               /*!< ID of CNC-MEDIA-MUXER */
    CNC_TRACE_MODULE_MEDIA_RECORDER,            /*!< ID of CNC-MEDIA-RECORDER */
    CNC_TRACE_MODULE_HTTP,                      /*!< ID of CNC-HTTP */
    CNC_TRACE_MODULE_WD,                        /*!< ID of CNC-WD */
    CNC_TRACE_MODULE_OSD,                       /*!< ID of CNC-OSD */
    CNC_TRACE_MODULE_BTV,                       /*!< ID of CNC-BTV */
    CNC_TRACE_MODULE_CRYPTO,                    /*!< ID of CNC-CRYPTO */
    CNC_TRACE_MODULE_DLNA_DMR,                  /*!< ID of CNC-DLNA-DMR */
    CNC_TRACE_MODULE_DLNA_DMP,                  /*!< ID of CNC-DLNA-DMP */
    CNC_TRACE_MODULE_DLNA_DMCP,                  /*!< ID of CNC-DLNA-DMC */
    CNC_TRACE_MODULE_DLNA_DMS,                  /*!< ID of CNC-DLNA-DMS */
    CNC_TRACE_MODULE_NETWORK,                   /*!< ID of CNC-NETWORK */
    CNC_TRACE_MODULE_NETWORK_PLUGIN,            /*!< ID of CNC-NETWORK-PLUGIN */
    CNC_TRACE_MODULE_UPDATE,                    /*!< ID of CNC-UPDATE */
    CNC_TRACE_MODULE_DFB,                       /*!< ID of CNC-DFB */
    CNC_TRACE_MODULE_WEB_ESPIAL,                /*!< ID of CNC-WEB-ESPIAL */
    CNC_TRACE_MODULE_SUBTITLE_RENDER,           /*!< ID of CNC Subtitle Render */
    CNC_TRACE_MODULE_IPREMOTE,                  /*!< ID of CNC-IPREMOTE */
    CNC_TRACE_MODULE_DIAL,                      /*!< ID of CNC-DIAL */
    CNC_TRACE_MODULE_AIRPLAY,                   /*!< ID of CNC-AIRPLAY */
    CNC_TRACE_MODULE_IR,                        /*!< ID of CNC-IR */
    CNC_TRACE_MODULE_APP_FRAMEWORK,             /*!< Generic ID for CNC Application Framework */
    CNC_TRACE_MODULE_APP,                       /*!< Generic ID for CNC Application */
    CNC_TRACE_MODULE_CNC,                       /*!< ID of CNC TODO: Remove this. Ideally not required */ 
    CNC_TRACE_MODULE_RUI,                       /*!< ID of CNC-RUI */

    /* eTraceNModules should always be the last entry */
    CNC_TRACE_NMODULES                	        /*!< Total number of modules */
} cncTraceModules_t;


/* ===================== Global variable declarations ===================== */
// NONE


/* ======================== Function declarations ========================= */
// NONE

#ifdef __cplusplus
}
#endif

#endif /* END: _CNC_TRACEMODULES_H_ */

