/*
 # COPYRIGHT NOTICE
 #
 #***************************************************************************

 The following software code is the property of Cavium, Inc.
 Cavium, Inc. reserves all rights in this software, including but not limited
 to copyright and shall be vested with all rights incidental thereto.

 Rights granted to you by or under any licence shall be limited to those
 explicitly granted. You may not record, store, reproduce, reverse engineer,
 decompile, inter-operate and/or transmit this software in any medium,
 electronic or otherwise, without the express written consent of Cavium, Inc.

 ALL RIGHTS RESERVED.

 Copyright 2011-2012, Cavium, Inc.
 #***************************************************************************
 #
 # END OF COPYRIGHT NOTICE
 #
 */
/**
 * @file cnc_ginga.h
 * @brief Wrapper implementation of GINGA-NCL Middleware Enginer
 * @ingroup btv
 */
#ifndef __CNC_GINGA_API_H__
#define __CNC_GINGA_API_H__

//#include "cnc_system.h"

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

typedef unsigned short int CNC_GINGA_WORD;
typedef unsigned int    CNC_GINGA_DWORD;
typedef CNC_GINGA_WORD   CNC_GINGA_ID;

typedef enum {
    CNC_GINGA_SUCCEED = 0,
    CNC_GINGA_FAILED = -1
} CNC_GINGA_RESULT;

typedef void* FILTER_HANDLER;
typedef void (*FilterCallback)( unsigned int pid, char *buffer, unsigned int size );

CNC_GINGA_RESULT CNC_GINGA_Init(int adapter, int frontend, int demux);

CNC_GINGA_RESULT CNC_GINGA_Release();

CNC_GINGA_RESULT CNC_GINGA_SetChannel(int channel);

FILTER_HANDLER CNC_GINGA_SetFilter(CNC_GINGA_ID pid, int timeout, CNC_GINGA_DWORD rate, CNC_GINGA_WORD maxBytes, FilterCallback call_back_function);

CNC_GINGA_RESULT CNC_GINGA_StartFilter(FILTER_HANDLER handle);

CNC_GINGA_RESULT CNC_GINGA_StopFilter(FILTER_HANDLER handle);

CNC_GINGA_RESULT CNC_GINGA_ReleaseFilter(FILTER_HANDLER handle);

CNC_GINGA_RESULT CNC_GINGA_GetStatus(int *state, int *signal);

void CNC_Ginga_SetAppStatus(int status);
int  CNC_Ginga_GetAppStatus(void);
void CNC_Ginga_PressKey(unsigned char key);

#ifdef __cplusplus
}
#endif // __cplusplus

#endif // __CNC_GINGA_API_H__

