/*
 # COPYRIGHT NOTICE
 #
 #***************************************************************************

 The following software code is the property of Cavium, Inc.
 Cavium, Inc. reserves all rights in this software, including but not limited
 to copyright and shall be vested with all rights incidental thereto.

 Rights granted to you by or under any licence shall be limited to those
 explicitly granted. You may not record, store, reproduce, reverse engineer,
 decompile, inter-operate and/or transmit this software in any medium,
 electronic or otherwise, without the express written consent of Cavium, Inc.

 ALL RIGHTS RESERVED.

 Copyright 2011-2012, Cavium, Inc.
 #***************************************************************************
 #
 # END OF COPYRIGHT NOTICE
 #
 */
/**
 * The CNCMEDIACTL_OLD library is deprecated
 */

#ifndef MEDIA_PLAY_H
#define MEDIA_PLAY_H

#include "cnc.h"
#include "cnc_demux.h"
#include "cnc_media.h"

#ifdef __cplusplus
extern "C" {
#endif

#define TIME_DOT_NUM 11


typedef struct {
    unsigned int            vpid;
    unsigned int            apid[8];
    unsigned int            spid[32];
    unsigned char           apidSum;
    unsigned char           spidSum;
    CSVID_STREAM_TYPE       v_type;
    CSAUD_STREAM_TYPE       a_type;
    unsigned int            s_type;
} cncMediaTSParseParams_t;

typedef struct  cncTSMediaCaptionInfo_t_
{
	CNC_UINT32   end_time;
	CNC_UINT32 	start_time;
	CNC_SINT32	str_cont[5];
	CNC_SINT32	str_size[5];
} cncTSMediaCaptionInfo_t;

typedef enum
{
      SRT=0,
      SUB_TYPE_UNKNOWN,
} cncTSMediaSubtitleFileType_t;

typedef struct  cncTSMediaCaptionFileNameInfo_t_
{
      CNC_BOOL exist;
      char name[1024];
      cncTSMediaSubtitleFileType_t type;
      CNC_BOOL en_exist;
      char en_name[1024];
      cncTSMediaSubtitleFileType_t en_type;
      cncSettingLanguage_t lang_use;
      CNC_SINT32 lang_num;
} cncTSMediaCaptionFileNameInfo_t;

typedef struct _cncTSMediaCaptionColor_t_
{
    unsigned char red;   /**< Red component */
    unsigned char green; /**< Green component */
    unsigned char blue;  /**< Blue component */
    unsigned char trans; /**< Transparency component */
} cncTSMediaCaptionColor_t;

typedef void (*cncTSMediaDrawCaptionCallback_t)(char (*)[255],CNC_SINT32,int,cncTSMediaCaptionColor_t);
typedef void (*cncTSMediaClearCaptionCallback_t)(void);

typedef enum
{
      SUB_OPEN_FAIL=0,
      SUB_OPEN_SUCCEED,
} cncTSMediaSubtitleError_t;

typedef enum
{
      SUB_RUN=0,
      SUB_STOP,
      SUB_PAUSE,
      SUB_RESUME,
      SUB_FW,
      SUB_FF,
      SUB_UNKNOWN,
} cncTSMediaSubtitleStatus_t;

typedef struct cncTSMediaCaptionTime_t_
{
      CNC_UINT32 time_dot[TIME_DOT_NUM];
      CNC_SINT32 site[TIME_DOT_NUM];
} cncTSMediaCaptionTime_t;

typedef enum {
    CNC_MEDIA_SOURCE_UNKNOWN = 0,
    CNC_MEDIA_SOURCE_FILE,
    CNC_MEDIA_SOURCE_BUFFER,
    CNC_MEDIA_SOURCE_BLURAY
} cncMediaSource_t;

typedef enum {
    SKIP_MODE_SET = 0,
    SKIP_MODE_CUR
} cncMediaSkipMode_t;

//void CNC_MediaFile_M2TSGetPGSTrack(cncMediaAudioStreamInfo_t *m2ts_info);
//CNC_BOOL CNC_MediaFile_GetPTSInfor(cncMediaPlayParameters_t* MediaParams);
Result_Type_e CNC_TSMedia_TSDataParse(const char* buf,  int size,cncMediaTSParseParams_t *params);
Result_Type_e CNC_TSMedia_M2TSDataParse(const char* buf,  int size,cncMediaTSParseParams_t *params);
/* File Group Play Function , Only support CNC_MEDIA_SOURCE_FILE mode and TS file type*/
Result_Type_e CNC_TSMedia_StartFileGroup(cncMediaSource_t source, char(*filegroup)[256], const CNC_UINT8 sum, cncMediaPlayParameters_t* params);
CNC_SINT32 CNC_TSMedia_GetCaptionStatus(void);
cncTSMediaSubtitleStatus_t CNC_TSMedia_CaptionOpen(char *file_name, cncTSMediaDrawCaptionCallback_t Drawcaption, cncTSMediaClearCaptionCallback_t  Clearcaption);
void CNC_TSMedia_CaptionClose(void);
void CNC_TSMedia_CaptionSeek(void);
char* CNC_TSMedia_GetCaptionFileName(void);

#ifdef __cplusplus
}
#endif

#endif //MEDIA_PLAY_H

