/**
 *# COPYRIGHT NOTICE
 *#
 *#***************************************************************************
 *
 *The following software code is the property of Cavium, Inc.
 *Cavium, Inc. reserves all rights in this software, including but not limited
 *to copyright and shall be vested with all rights incidental thereto.
 
 *Rights granted to you by or under any license shall be limited to those
 *explicitly granted. You may not record, store, reproduce, reverse engineer,
 *decompile, inter-operate and/or transmit this software in any medium,
 *electronic or otherwise, without the express written consent of Cavium, Inc.
 
 *ALL RIGHTS RESERVED.
 
 *Copyright 2013, Cavium, Inc.
 *#***************************************************************************
 *#
 *# END OF COPYRIGHT NOTICE
 *#
 */
 
#ifndef _CNC_NET_EVENTS_H_
#define _CNC_NET_EVENTS_H_
 
#ifdef __cplusplus
extern "C" {
#endif

/**
 * \brief Events in eth mode
 *
 */
typedef enum _cncNetEventEth_t
{
    CNC_NET_EVENT_ETH_LINK_UP = 0x1,
    CNC_NET_EVENT_ETH_LINK_DOWN = ( 0x1 << 1 ),
    CNC_NET_EVENT_ETH_IP_SETUP = ( 0x1 << 2 ),
    CNC_NET_EVENT_ETH_CONNECTION_FAILED = ( 0x1 << 3 ),
}cncNetEventEth_t;

/**
 * \brief Events in wifi station mode
 *
 */
typedef enum _cncNetEventSta_t
{
    CNC_NET_EVENT_STA_STARTING = 0x1,
    CNC_NET_EVENT_STA_STARTED = ( 0x1 << 1 ),
    CNC_NET_EVENT_STA_CONNECTION_ATTEMPT = ( 0x1 << 2 ),
    CNC_NET_EVENT_STA_SCANNING = ( 0x1 << 3 ),
    CNC_NET_EVENT_STA_SCAN_RESULTS = ( 0x1 << 4 ),
    CNC_NET_EVENT_STA_CONNECTING = ( 0x1 << 5 ),
    CNC_NET_EVENT_STA_CONNECTED = ( 0x1 << 6 ),
    CNC_NET_EVENT_STA_IP_ACQUIRED = ( 0x1 << 7 ),
    CNC_NET_EVENT_STA_DISCONNECTED = ( 0x1 << 8 ),
    CNC_NET_EVENT_STA_CONNECTION_ATTEMPT_FAILED = ( 0x1 << 9 ),
    CNC_NET_EVENT_STA_CONNECTION_ATTEMPT_STOPPED = ( 0x1 << 10 ),
    CNC_NET_EVENT_STA_STOPPING = ( 0x1 << 11 ),
    CNC_NET_EVENT_STA_STOPPED = ( 0x1 << 12 ),
}cncNetEventSta_t;

/**
 * \brief events in wifi AP mode
 *
 */
typedef enum _cncNetEventAp_t
{
    CNC_NET_EVENT_AP_STARTING = 0x1,
    CNC_NET_EVENT_AP_STARTED = ( 0x1 << 1 ),
    CNC_NET_EVENT_AP_CONNECTING = ( 0x1 << 2 ),
    CNC_NET_EVENT_AP_STA_CONNECTED = ( 0x1 << 3 ),
    CNC_NET_EVENT_AP_IP_ASSIGNED = ( 0x1 << 4 ),
    CNC_NET_EVENT_AP_STA_DISCONNECTED = ( 0x1 << 5 ),
    CNC_NET_EVENT_AP_IDLE_TIMEOUT = ( 0x1 << 6 ),
    CNC_NET_EVENT_AP_WPS_PBC_TIMEOUT = ( 0x1 << 7 ),
    CNC_NET_EVENT_AP_STA_IDLE_TIMEOUT = ( 0x1 << 8 ),
    CNC_NET_EVENT_AP_STOPPING = ( 0x1 << 9 ),
    CNC_NET_EVENT_AP_STOPPED = ( 0x1 << 10 ),
}cncNetEventAp_t;

/**
 * \brief events in wifi P2P mode
 *
 */
typedef enum _cncNetEventP2p_t
{
    CNC_NET_EVENT_P2P_STARTING = 0x1,
    CNC_NET_EVENT_P2P_STARTED = ( 0x1 << 1 ),
    CNC_NET_EVENT_P2P_DEVICE_FOUND = ( 0x1 << 2 ),
    CNC_NET_EVENT_P2P_CONNECTING = ( 0x1 << 3 ),
    CNC_NET_EVENT_P2P_CONNECTED = ( 0x1 << 4 ),
    CNC_NET_EVENT_P2P_WFD_CONNECTED = ( 0x1 << 5 ),
    CNC_NET_EVENT_P2P_IP_ASSIGNED = ( 0x1 << 6 ),
    CNC_NET_EVENT_P2P_IP_ACQUIRED = ( 0x1 << 7 ),
    CNC_NET_EVENT_P2P_DISCONNECTED = ( 0x1 << 8 ),
    CNC_NET_EVENT_P2P_CONNECTION_ATTEMPT_FAILED = ( 0x1 << 9 ),
    CNC_NET_EVENT_P2P_STOPPING = ( 0x1 << 10 ),
    CNC_NET_EVENT_P2P_STOPPED = ( 0x1 << 11 ),
}cncNetEventP2p_t;

/**
 * \brief events in P2P AutoGO mode
 *
 */
typedef enum _cncNetEventP2pAutoGO_t
{
    CNC_NET_EVENT_P2P_AUTOGO_STARTING = 0x1,
    CNC_NET_EVENT_P2P_AUTOGO_STARTED = ( 0x1 << 1 ),
    CNC_NET_EVENT_P2P_AUTOGO_DEVICE_FOUND = ( 0x1 << 2 ),
    CNC_NET_EVENT_P2P_AUTOGO_CONNECTING = ( 0x1 << 3 ),
    CNC_NET_EVENT_P2P_AUTOGO_STA_CONNECTED = ( 0x1 << 4 ),
    CNC_NET_EVENT_P2P_AUTOGO_IP_ASSIGNED = ( 0x1 << 5 ),
    CNC_NET_EVENT_P2P_AUTOGO_STA_DISCONNECTED = ( 0x1 << 6 ),
    CNC_NET_EVENT_P2P_AUTOGO_IDLE_TIMEOUT = ( 0x1 << 7 ),
    CNC_NET_EVENT_P2P_AUTOGO_WPS_TIMEOUT = ( 0x1 << 8 ),
    CNC_NET_EVENT_P2P_AUTOGO_STA_IDLE_TIMEOUT = ( 0x1 << 9 ),
    CNC_NET_EVENT_P2P_AUTOGO_STOPPING = ( 0x1 << 10 ),
    CNC_NET_EVENT_P2P_AUTOGO_STOPPED = ( 0x1 << 11 )
}cncNetEventP2pAutoGO_t;

/**
 * \brief Events in widi station mode
 *
 */
typedef enum _cncNetEventWidiSta_t
{
    CNC_NET_EVENT_WIDI_STA_STARTING = 0x1,
    CNC_NET_EVENT_WIDI_STA_STARTED = ( 0x1 << 1 ),
    CNC_NET_EVENT_WIDI_STA_BSS_FOUND = ( 0x1 << 2 ),
    CNC_NET_EVENT_WIDI_STA_CONNECTING = ( 0x1 << 3 ),
    CNC_NET_EVENT_WIDI_STA_CONNECTED = ( 0x1 << 4 ),
    CNC_NET_EVENT_WIDI_STA_IP_ACQUIRED = ( 0x1 << 5 ),
    CNC_NET_EVENT_WIDI_STA_DISCONNECTED = ( 0x1 << 6 ),
    CNC_NET_EVENT_WIDI_STA_STOPPING = ( 0x1 << 7 ),
    CNC_NET_EVENT_WIDI_STA_STOPPED = ( 0x1 << 8 ),
}cncNetEventWidiSta_t;

/**
 * \brief Connection failure reasons in station mode.
 *
 */
typedef enum _cncNetStaDisconnectReason_t
{
    CNC_NET_STA_DISCONNECT_REASON_UNKNOWN,
    CNC_NET_STA_DISCONNECT_REASON_WPS_FAILED,
    CNC_NET_STA_DISCONNECT_REASON_NO_IP,
    CNC_NET_STA_DISCONNECT_REASON_EAPOL_FAILED,
    CNC_NET_STA_DISCONNECT_REASON_NEW_CONNECTION
}cncNetStaDisconnectReason_t;

/**
 * \brief P2P Connection progress states
 *
 */
typedef enum _cncNetP2pConnectingState_t
{
    CNC_NET_P2P_CONNECTING_STATE_WAITING_FOR_PBC=1,
    CNC_NET_P2P_CONNECTING_STATE_DISPLAY_PIN,
    CNC_NET_P2P_CONNECTING_STATE_PBC,
    CNC_NET_P2P_CONNECTING_STATE_PBC_REQUEST_DENY,
    CNC_NET_P2P_CONNECTING_STATE_REINVOKE_GROUP,
    CNC_NET_P2P_CONNECTING_STATE_GROUP_FORMED,
    CNC_NET_P2P_CONNECTING_STATE_WPS,
    CNC_NET_P2P_CONNECTING_STATE_CONNECT,
    CNC_NET_P2P_CONNECTING_STATE_GROUP_STARTED,
    CNC_NET_P2P_CONNECTING_STATE_IP
}cncNetP2pConnectingState_t;

/**
 * \brief P2P disconnection reasons
 *
 */
typedef enum _cncNetP2pDisconnectReason_t
{
    CNC_NET_P2P_DISCONNECT_REASON_UNKNOWN,
    CNC_NET_P2P_DISCONNECT_REASON_REQUESTED,
    CNC_NET_P2P_DISCONNECT_REASON_PROV_DISC_FAILED,
    CNC_NET_P2P_DISCONNECT_REASON_GROUP_FORM_FAILED,
    CNC_NET_P2P_DISCONNECT_REASON_GROUP_FORM_TIMEOUT,
    CNC_NET_P2P_DISCONNECT_REASON_WPS_FAIL,
    CNC_NET_P2P_DISCONNECT_REASON_WPS_TIMEOUT,
    CNC_NET_P2P_DISCONNECT_REASON_INVALID_PIN,
    CNC_NET_P2P_DISCONNECT_REASON_IP_FAIL,
    CNC_NET_P2P_DISCONNECT_REASON_PEER_DISCONNECTED,
}cncNetP2pDisconnectReason_t;

/**
 * \brief WIDI Connection progress states
 *
 */
typedef enum _cncNetwidiStaConnectingState_t
{
    CNC_NET_WIDI_STA_CONNECTING_STATE_DISPLAY_PIN,
    CNC_NET_WIDI_STA_CONNECTING_STATE_PBC,
    CNC_NET_WIDI_STA_CONNECTING_STATE_WPS,
    CNC_NET_WIDI_STA_CONNECTING_STATE_WPS_SUCCESS,
    CNC_NET_WIDI_STA_CONNECTING_STATE_WPS_FAIL,
    CNC_NET_WIDI_STA_CONNECTING_STATE_IP
}cncNetWidiStaConnectingState_t;

/**
 * \brief Connection attempt failure reasons in station mode.
 *
 */
typedef enum _cncNetStaConnectFailReason_t
{
    CNC_NET_STA_CONNECT_FAIL_REASON_UNKNOWN,
    CNC_NET_STA_CONNECT_FAIL_REASON_NO_AP,
    CNC_NET_STA_CONNECT_FAIL_REASON_NO_ASSOC,
    CNC_NET_STA_CONNECT_FAIL_REASON_NO_IP,
    CNC_NET_STA_CONNECT_FAIL_REASON_AP_LOST,
    CNC_NET_STA_CONNECT_FAIL_REASON_WPS_FAILED,
}cncNetStaConnectFailReason_t;

/**
 * \brief event type
 *
 * This structure will be used to subscribe for events and receive a network event
 */
typedef struct _cncNetEventType_t
{
    cncNetEventEth_t eth;

    cncNetEventSta_t sta;

    cncNetEventAp_t ap;

    cncNetEventP2p_t p2p;

    cncNetEventP2pAutoGO_t p2pAutoGO;

    cncNetEventWidiSta_t widiSta;

}cncNetEventType_t;

/**
 * \brief Information of events
 *
 * CNC_NET_EVENT_STA_CONNECTION_ATTEMPT
 * CNC_NET_EVENT_STA_CONNECTION_ATTEMPT_FAILED
 */
typedef struct _cncNetEventStaConnectionAttempt_t
{
    CNC_SINT32 attempt;                         /**< number of attempt */

    cncNetStaConnectFailReason_t reason;         /**< reson for failure */

}cncNetEventStaConnectionAttempt_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_STA_CONNECTING
 */
typedef struct _cncNetEventStaConnecting_t
{
    CNC_CHAR a_bssid[CNC_NET_MAC_STR_LEN];      /**< MacAddress of AP */

    CNC_CHAR a_ssid[CNC_NET_WIFI_SSID_LEN];     /**< SSID of AP */

    cncNetAuth_t auth;                          /**< authentication method used for connection */

}cncNetEventStaConnecting_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_STA_CONNECTED
 */
typedef struct _cncNetEventStaConnected_t
{
    CNC_CHAR a_bssid[CNC_NET_MAC_STR_LEN];      /**< MacAddress of AP */

    CNC_CHAR a_ssid[CNC_NET_WIFI_SSID_LEN];     /**< SSID of AP */

    CNC_SINT32 freq;                            /**< Frequency of AP */

    cncNetIpParams_t ip;                        /**< Acquired IP Address */

}cncNetEventStaConnected_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_STA_DISCONNECTED
 */
typedef struct _cncNetEventStaDisconnected_t
{
    cncNetStaDisconnectReason_t reason;       /**< reason */
}cncNetEventStaDisconnected_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_AP_STARTED
 */
typedef struct _cncNetEventApStarted_t
{
    CNC_CHAR a_bssid[CNC_NET_MAC_STR_LEN];       /**< MacAddress of AP */

    CNC_CHAR a_ssid[CNC_NET_WIFI_SSID_LEN];      /**< SSID of AP */

    CNC_SINT32 freq;                            /**< Frequency of AP */

    cncNetIpParams_t ip;                        /**< Acquired IP Address */

}cncNetEventApStarted_t;


/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_AP_CONNECTING
 */
typedef struct _cncNetEventApConnecting_t
{
    CNC_CHAR a_bssid[CNC_NET_MAC_STR_LEN];      /**< MacAddress of STA */

    CNC_CHAR a_ssid[CNC_NET_WIFI_SSID_LEN];     /**< SSID of STA */

    cncNetAuth_t auth;                          /**< authentication method used for connection */

}cncNetEventApConnecting_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_AP_CONNECTED
 */
typedef struct _cncNetEventApConnected_t
{
    CNC_CHAR a_bssid[CNC_NET_MAC_STR_LEN];       /**< MacAddress of STA */

    CNC_CHAR a_ssid[CNC_NET_WIFI_SSID_LEN];      /**< SSID of STA */

    CNC_SINT32 freq;                            /**< Frequency of STA */
}cncNetEventApConnected_t;



/**
 * \brief Information of events
 *
 * CNC_NET_EVENT_AP_STA_CONNECTED
 * CNC_NET_EVENT_AP_STA_DISCONNECTED
 * CNC_NET_EVENT_AP_STA_IDLE_TIMEOUT
 */
typedef struct _cncNetEventApStaInfo_t
{
    CNC_CHAR a_addr[CNC_NET_MAC_STR_LEN];        /**< Mac address of station */

    CNC_SINT32 signal;                          /**< signal of station */
}cncNetEventApStaInfo_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_P2P_CONNECTING
 */
typedef struct _cncNetEventP2pConnecting_t
{
    CNC_CHAR a_peerAddr[CNC_NET_MAC_STR_LEN];       /**< MacAddress of peer device */

    cncNetP2pConnectingState_t state;               /**< current state of connection */

    CNC_CHAR a_pin[16];                             /**< pin to be displayed, valid in state=CNC_NET_P2P_CONNECTING_STATE_DISPLAY_PIN */

    CNC_CHAR a_peerName[CNC_NET_WIFI_SSID_LEN];     /**< Device Name valid in state=CNC_NET_P2P_CONNECTING_STATE_DISPLAY_PIN, CNC_NET_P2P_CONNECTING_STATE_PBC */

    CNC_UINT32 timeout;                             /** <timeout of connecting state */
    
}cncNetEventP2pConnecting_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_P2P_DISCONNECTED
 */
typedef struct _cncNetEventP2pDisconnected_t
{
    cncNetP2pDisconnectReason_t reason;       /**< reason */
}cncNetEventP2pDisconnected_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_P2P_CONNECTED
 */
typedef struct _cncNetEventP2pConnected_t
{
    CNC_CHAR a_peerAddr[CNC_NET_MAC_STR_LEN];       /**< MacAddress of peer device */

    cncNetIpParams_t ip;                            /**< Acquired IP Address */

}cncNetEventP2pConnected_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_P2P_GROUP_STARTED for P2P AUTO GO
 */
typedef struct _cncNetEventP2pAutoGoStarted_t
{
    CNC_CHAR a_ssid[CNC_NET_WIFI_SSID_LEN];       /**< ssid of P2P AUTO GO */

    CNC_CHAR a_passphrase[CNC_NET_WPA_PSK_LEN]; /**< passphrase in case of p2pGO or p2pAutoGO */

    CNC_SINT32 freq;                            /**< Frequency of P2P AUTO GO */
}cncNetEventP2pAutoGoStarted_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_AP_STA_CONNECTED for P2P AUTO GO
 */
typedef struct _cncNetEventP2pAutoGoStaInfo_t
{
    CNC_CHAR a_addr[CNC_NET_MAC_STR_LEN];        /**< Mac address of station */

    CNC_SINT32 signal;                          /**< signal of station */
}cncNetEventP2pAutoGoStaInfo_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_P2P_AUTOGO_CONNECTING
 */
typedef struct _cncNetEventP2pAutoGoConnecting_t
{
    cncNetAuth_t auth;                          /**< authentication method used for connection */

}cncNetEventP2pAutoGoConnecting_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_WFD_CONNECTED
 */
typedef struct _cncNetEventWfdConnected_t
{
    CNC_CHAR a_peerAddr[CNC_NET_MAC_STR_LEN];       /**< MacAddress of peer device */

    CNC_CHAR a_peerIp[CNC_NET_IP_STR_LEN];          /**< ip address of peer device */

    CNC_SINT32 port;                                /**< wfd port of peer device */

    cncNetIpParams_t ip;                            /**< Acquired IP Address */

}cncNetEventWfdConnected_t;

/**
 * \brief Information of event
 *
 * CNC_NET_EVENT_WIDI_STA_CONNECTING
 */
typedef struct _cncNetEventWidiStaConnecting_t
{
    CNC_CHAR a_peerAddr[CNC_NET_MAC_STR_LEN];       /**< MacAddress of peer device */

    cncNetWidiStaConnectingState_t state;           /**< current state of connection */

    CNC_CHAR a_ssid[CNC_NET_WIFI_SSID_LEN];         /**< SSID of AP */

    CNC_CHAR a_psk[CNC_NET_WPA_PSK_LEN];            /**< wpa psk */

    CNC_CHAR a_pin[16];                             /**< pin to be displayed, valid in state=CNC_NET_WIDI_STA_CONNECTING_STATE_DISPLAY_PIN */

}cncNetEventWidiStaConnecting_t;

/**
 * \brief Bss information returned in scan results iterator
 *
 */
typedef struct _cncNetEventBssInfo_t
{
    CNC_CHAR a_bssid[CNC_NET_MAC_STR_LEN];               /**< bssid */

    CNC_UINT32 freq;                                    /**< frequency */

    CNC_UINT32 signal;                                  /**< signal in rssi eg. ( -30(high) to -100(low) ) */

    CNC_CHAR a_ssid[CNC_NET_WIFI_SSID_LEN];              /**< ssid */

    CNC_CHAR a_infoElements[1024];                      /**< information elements if any */

} cncNetEventBssInfo_t;

/**
 * \brief Event information provided in event callback
 *
 */
typedef struct _cncNetEvent_t
{
    cncNetType_t type;                           /**< Type of network defined in @cncNetType_t */

    cncNetSubType_t subType;                     /**< SubType of network defined in @cncNetSubType_t */

    cncNetEventType_t event;                     /**< only 1 event will be set according to type/subtype */

    union
    {
        cncNetEventStaConnectionAttempt_t staConnectionAttempt; /**< CNC_NET_EVENT_STA_CONNECTION_ATTEMPT, CNC_NET_EVENT_STA_CONNECTION_ATTEMPT_FAILED */

        cncNetEventStaConnecting_t staConnecting;               /**< CNC_NET_EVENT_STA_CONNECTING */

        cncNetEventStaConnected_t staConnected;                 /**< CNC_NET_EVENT_STA_CONNECTED */

        cncNetIpParams_t ip;                                    /**< CNC_NET_EVENT_STA_IP_ACQUIRED, CNC_NET_EVENT_AP_IP_ASSIGNED ,CNC_NET_EVENT_ETH_IP_SETUP */

        cncNetEventStaDisconnected_t staDisconnected;           /**< CNC_NET_EVENT_STA_DISCONNECTED */

        cncNetEventApStarted_t apStarted;                       /**< CNC_NET_EVENT_AP_STARTED */
        
        cncNetEventApConnecting_t apConnecting;                 /**< CNC_NET_EVENT_AP_CONNECTING */

        cncNetEventApConnected_t apConnected;                  /**< CNC_NET_EVENT_AP_CONNECTED */

        cncNetEventApStaInfo_t apStaInfo;                       /**< CNC_NET_EVENT_AP_STA_CONNECTED, CNC_NET_EVENT_AP_STA_DISCONNECTED,
                                                                        CNC_NET_EVENT_AP_STA_IDLE_TIMEOUT */
        cncNetEventP2pConnecting_t p2pConnecting;               /**< CNC_NET_EVENT_P2P_CONNECTING */

        cncNetEventP2pDisconnected_t p2pDisconnected;           /**< CNC_NET_EVENT_P2P_DISCONNECTED */

        cncNetEventP2pConnected_t p2pConnected;                 /**< CNC_NET_EVENT_P2P_CONNECTED */
        
        cncNetEventP2pAutoGoStarted_t p2pAutoGoStarted;			/**< CNC_NET_EVENT_P2P_GROUP_STARTED */
        
        cncNetEventP2pAutoGoStaInfo_t p2pAutoGoStaInfo;			/**< CNC_NET_EVENT_AP_STA_CONNECTED */

        cncNetEventWfdConnected_t wfdConnected;                 /**< CNC_NET_EVENT_WFD_CONNECTED */

        cncNetEventWidiStaConnecting_t widiStaConnecting;       /**< CNC_NET_EVENT_WIDI_STA_CONNECTING */

        cncNetEventBssInfo_t bssInfo;                           /**< CNC_NET_EVENT_WIDI_STA_BSS_FOUND */

        cncNetEventP2pAutoGoConnecting_t p2pAutoGoConnecting;	/**< CNC_NET_EVENT_P2P_AUTOGO_CONNECTING */

    }info;

}cncNetEvent_t;

/**
 * \brief Event information to be provided when subscribing for event callbacks
 *
 */
typedef struct _cncNetEventsSubscribe_t
{
    cncNetType_t type;           /**< Type of networks defined in @cncNetType_t */

    cncNetSubType_t subType;     /**< SubType of networks defined in @cncNetSubType_t */

    cncNetEventType_t events;    /**< 1 or more events will be set according to type/subtype */
}cncNetEventsSubscribe_t;

#ifdef __cplusplus
}
#endif
 
#endif /* END:  _CNC_NET_EVENTS_H_ */

