/*
 # COPYRIGHT NOTICE
 #
 #***************************************************************************

 The following software code is the property of Cavium Inc,
 Cavium Inc, reserves all rights in this software, including but not limited
 to copyright and shall be vested with all rights incidental thereto.

 Rights granted to you by or under any licence shall be limited to those
 explicitly granted. You may not record, store, reproduce, reverse engineer,
 decompile, inter-operate and/or transmit this software in any medium,
 electronic or otherwise, without the express written consent of Cavium Inc,

 ALL RIGHTS RESERVED.

 Copyright 2013-2014, Cavium Inc.
 #***************************************************************************
 #
 # END OF COPYRIGHT NOTICE
 #
 */
#ifndef CNC_UPNP_ADVERTISE_H_
#define CNC_UPNP_ADVERTISE_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "cnc_common_typedef.h"
#include "cnc_common_error.h"

/*
 * Struct : cncUpnpDevAdvertiseDetails_t
 *
 **/
typedef struct _cncUpnpDevAdvertiseDetails_t
{
    CNC_CHAR        deviceTypeName[128];            //Advertise <DeviceClass>-Discovery
    CNC_CHAR        friendlyName[128];
    CNC_CHAR        manufacturer[128];
    CNC_CHAR        manufacturerUrl[256];
    CNC_CHAR        modelDescription[128];
    CNC_CHAR        modelName[128];
    CNC_CHAR        modelNumber[32];
    CNC_CHAR        modelUrl[256];
    CNC_CHAR        serialNumber[128];
    CNC_CHAR        uuid[48];

}cncUpnpDevAdvertiseDetails_t;


/**
 * Advertiser Handle
 */
typedef void* cncUpnpDevAdvertiser_t;

/*
 * Allocate and Initializing Global members
 **/
E_cncErrCode_t CNC_UPNP_DevAdvertiseInit(void);


/*
 * Clear and Destroy Global members
 **/
E_cncErrCode_t CNC_UPNP_DevAdvertiseDeInit(void);


/*
 * Create an instance of Advertising
 **/
E_cncErrCode_t CNC_UPNP_DevAdvertiseCreate(cncUpnpDevAdvertiser_t       *pp_handle,
                                           cncUpnpDevAdvertiseDetails_t *p_s_advertiseDetails);

/*
 * Destroy advertising instance
 **/
E_cncErrCode_t CNC_UPNP_DevAdvertiseDestroy(cncUpnpDevAdvertiser_t handle);


/*
 * Send Initial BYE-BYE and ALIVE message
 **/
E_cncErrCode_t CNC_UPNP_DevAdvertiseStart(cncUpnpDevAdvertiser_t handle);


/*
 * Send BYE-BYE message
 **/
E_cncErrCode_t CNC_UPNP_DevAdvertiseStop(cncUpnpDevAdvertiser_t handle);


#ifdef __cplusplus
}
#endif

#endif /* CNC_UPNP_ADVERTISE_H_ */
