/*
 # COPYRIGHT NOTICE
 #
 #***************************************************************************

 The following software code is the property of Cavium, Inc.
 Cavium, Inc. reserves all rights in this software, including but not limited
 to copyright and shall be vested with all rights incidental thereto.

 Rights granted to you by or under any licence shall be limited to those
 explicitly granted. You may not record, store, reproduce, reverse engineer,
 decompile, inter-operate and/or transmit this software in any medium,
 electronic or otherwise, without the express written consent of Cavium, Inc.

 ALL RIGHTS RESERVED.

 Copyright 2012, Cavium, Inc.
 #***************************************************************************
 #
 # END OF COPYRIGHT NOTICE
 #
 */

/**
 * @file cnc_wd.h
 * @ingroup wd
 * The CNCWD library enables the development of applications using the WFD, WiDi, WiVu protocols.
 */

#ifndef __CNC_WD_H__
#define __CNC_WD_H__

//------------------------------------------------------------------------------

#define NUM_AUDIO_FORMATS 1
#define NUM_LATENCIES 2
#define NUM_TEST_PARAMETERS 13
#define NUM_WFD_ERRORS 9
#define TIMEOUT_SERVER 30

#define NUM_CEA_RESOLUTIONS 17
#define NUM_VESA_RESOLUTIONS 30
#define NUM_HH_RESOLUTIONS 12

#define TIMEOUT_JITTER_BUFFER 900

#define WAIT 0
#define DONT_WAIT 1
//------------------------------------------------------------------------------
typedef enum _cncWDExtraOptions_t {
    TRANSIT_WFD,
    TRANSIT_DLNA,
    NUM_EXTRA_COMMANDS
} cncWDExtraOptions_t;

//------------------------------------------------------------------------------

typedef enum _cncWDActiveStatus_t{
    CNC_WD_DISABLE=0,
    CNC_WD_ENABLE=1,
} cncWDActiveStatus_t;

typedef enum _cncWDDevice_t{
    WFD_SOURCE,
    WFD_PRIMARY_SINK,
    WFD_SECONDARY_SINK,
    WFD_DUAL_ROLE,
} cncWDDevice_t;
//------------------------------------------------------------------------------

/**
* Date structure
*/
typedef struct _cncWDDate_t{
    int iYear;
    char iMonth[4];
    int iDay;
    int iHour;
    int iMinute;
    int iSec;
    char iTime[5];
} cncWDDate_t;
//------------------------------------------------------------------------------

CNC_CHAR *dotted_addr(CNC_UINT8 *bytes);


#endif // __CNC_WD_H__
