/*
 # COPYRIGHT NOTICE
 #
 #***************************************************************************

 The following software code is the property of Cavium Inc.
 Cavium Inc reserves all rights in this software, including but not limited
 to copyright and shall be vested with all rights incidental thereto.

 Rights granted to you by or under any licence shall be limited to those
 explicitly granted. You may not record, store, reproduce, reverse engineer,
 decompile, inter-operate and/or transmit this software in any medium,
 electronic or otherwise, without the express written consent of Cavium Inc.

 ALL RIGHTS RESERVED.

 Copyright 2011-2013, Cavium Inc
 #***************************************************************************
 #
 # END OF COPYRIGHT NOTICE
 #
 */

/**
 * Wrapper for Browser Text Codec
 * @file cnc_browserTextCodec.h
 * @ingroup web
 */

#ifndef __CNC_BROWSER_TEXT_CODEC_H__
#define __CNC_BROWSER_TEXT_CODEC_H__

/* ============================= User Includes ============================ */
#include "cnc_browserTypes.h"

#ifdef __cplusplus
extern "C"
{
#endif


typedef struct
{
	/* decoding a buffer of encoded string
	 *
	 * @param charset - the encoding charset name
	 * @param buf - the encoded buffer
	 * @param buf_size - the length of the buffer
	 * @param ret_str - the buffer to hold the decoded string
	 *
	 * @return
	 * 		BrowserI_Success, the string is successfully decoded, and ret_str is filled in
	 * 		BrowserI_Failure, decoding failed, ret_str is not touched.
	 */
	CNC_BrowserI_ReturnCode_e (*decode)(const char* charset, const char* buf, int buf_size, CNC_BrowserString_t* ret_str);

} CNC_Browser_TextCodec_t;

/**
 * Register the text coded with the browser.
 * @param codec -
 */
void CNC_Browser_registerTextCodec(CNC_Browser_TextCodec_t *codec);

#ifdef __cplusplus
}
#endif

#endif //__CNC_BROWSER_TEXT_CODEC_H__
