/*-----------------------------------------------------------------------
//
// Proprietary Information of Elliptic Technologies
// Copyright (C) 2001-2011, all rights reserved
// Elliptic Technologies, Inc.
//
// As part of our confidentiality  agreement, Elliptic Technologies and
// the Company, as  a  Receiving Party, of  this  information  agrees to
// keep strictly  confidential  all Proprietary Information  so received
// from Elliptic Technologies. Such Proprietary Information can be used
// solely for  the  purpose  of evaluating  and/or conducting a proposed
// business  relationship  or  transaction  between  the  parties.  Each
// Party  agrees  that  any  and  all  Proprietary  Information  is  and
// shall remain confidential and the property of Elliptic Technologies.
// The  Company  may  not  use  any of  the  Proprietary  Information of
// Elliptic Technologies for any purpose other  than  the  above-stated
// purpose  without the prior written consent of Elliptic Technologies.
//
// This information is further subject to the terms and conditions of
// the DTLA license agreement.
//-----------------------------------------------------------------------
//
// Project:
//
//   DTCP-IP
//
// Description:
//
//
// This file defined global interface DTCP structures  and functions.
//
//
//-----------------------------------------------------------------------
//
// Language:         C
//
//
// Filename:         $Source: /home/repository/cvsrep/dtcp_sdk/dtcp/include/dtcp_ex.h,v $
// Current Revision: $Revision: 1.25 $
// Last Updated:     $Date: 2011/09/20 15:37:31 $
// Current Tag:      $Name: DTCP-IP-SDK-V53-OFF-THE-SHELF-07-FEB-2012 $
//
//
//-----------------------------------------------------------------------*/


#ifndef _DTCP_EX_H_
#define _DTCP_EX_H_

int dtcp_rng_f_close(void);
int dtcp_rng_f_init (unsigned char * seed, int ssize, unsigned char (*get_cycle_time)(void));
void dtcp_rng_f_read_seed(unsigned char * buf);
int dtcp_rng (unsigned char * buf, int size);


// Crypto ciphers and key generation
int dtcp_ake_X_v(unsigned char * X_k, unsigned char *X_v, dtcp_dtla_constants *dtla);
int dtcp_ake_K_auth_R_ (unsigned char * Kv, unsigned char * An, unsigned char * Bn, unsigned char * R, unsigned char * Kauth);
int dtcp_ake_K_v_       (unsigned char * Xk[], unsigned char * Kv, unsigned char * Xk_sv);
int dtcp_cp_j_aes (unsigned char * c_Kx, unsigned char * c_Nc, unsigned char emi, unsigned char * c_Kc, dtcp_dtla_constants *dtla);
int dtcp_cp_j_m6 (unsigned char * c_Kx, unsigned char * c_Nc, unsigned char emi, unsigned char * c_Kc, dtcp_dtla_constants *dtla);
int dtcp_cp_iv_aes (unsigned char *Kc, unsigned char *Nc, unsigned char *IV, dtcp_dtla_constants *dtla);
int dtcp_ake_K_auth_full_(unsigned char * AB_v,unsigned char * BA_k, unsigned char *K_auth, dtcp_dtla_constants *dtla);
int dtcp_crypto_ecc_rand_xv(unsigned char *xv, dtcp_dtla_constants *dtla );
int dtcp_check_nonce(unsigned char *peer, unsigned char *host);


int dtcp_initiate_BG_RTT_check(int handle,unsigned char sink, dtcp_device_info *info);
int dtcp_increment_n_rtt(dtcp_device_peer *peer);
int dtcp_constant_check(void);

void dtcp_crypto_init(int par);
void dtcp_cp_crypto_init(int par);

#endif


