/*-----------------------------------------------------------------------
//
// Proprietary Information of Elliptic Technologies
// Copyright (C) 2002, all rights reserved
// Elliptic Technologies, Inc.
//
// As part of our confidentiality  agreement, Elliptic Technologies and
// the Company, as  a  Receiving Party, of  this  information  agrees to
// keep strictly  confidential  all Proprietary Information  so received
// from Elliptic Technologies. Such Proprietary Information can be used
// solely for  the  purpose  of evaluating  and/or conducting a proposed
// business  relationship  or  transaction  between  the  parties.  Each
// Party  agrees  that  any  and  all  Proprietary  Information  is  and
// shall remain confidential and the property of Elliptic Technologies.
// The  Company  may  not  use  any of  the  Proprietary  Information of
// Elliptic Technologies for any purpose other  than  the  above-stated
// purpose  without the prior written consent of Elliptic Technologies.
//
// This information is further subject to the terms and conditions of
// the DTLA license agreement.
//-----------------------------------------------------------------------
//
// Project:
//
//   ELP - DTCP
//
// Description:
//
//
//
//
//-----------------------------------------------------------------------
//
// Language:         C
//
//
// Filename:         $Source: /home/repository/cvsrep/dtcp_sdk/dtcp/include/dtcp_ip.h,v $
// Current Revision: $Revision: 1.35 $
// Last Updated:     $Date: 2011/12/05 17:39:32 $
// Current Tag:      $Name: DTCP-IP-SDK-V53-OFF-THE-SHELF-07-FEB-2012 $
//
//
//-----------------------------------------------------------------------*/


#ifndef _DTCP_IP_H_
#define _DTCP_IP_H_


#define DTCP_IP_PACKET_TYPE (uint8_t)1
#pragma pack(1)
typedef struct dtcp_ip_packet_
{
  uint8_t  type;
  uint16_t length;
}dtcp_ip_packet;
typedef struct dtcp_ip_packet_header_
{
  uint8_t  type;
  uint16_t length;
  uint8_t  ctype;
  uint8_t  ake_id;
  uint8_t  subfunction;
  uint8_t  ake_procedure;
  uint8_t  exchange_key;
  uint8_t  subfunction_dependent;
  uint8_t  ake_label;
  uint8_t  status;
}dtcp_ip_packet_header;

#pragma pack()


int dtcp_net_init( void );
int dtcp_net_connect(dtcp_net *peer);
int dtcp_net_initialized(dtcp_net *dev);
int dtcp_net_source_init(dtcp_net *peer, unsigned short port,  int flags );
int dtcp_net_source_accept(dtcp_net *peer,dtcp_net *host);
int dtcp_net_source_cleanup(dtcp_net *peer);

int dtcp_ip_close(dtcp_net *peer);

int dtcp_ip_write(dtcp_net *peer, unsigned char *packet, int size);


int dtcp_ip_ake_send(dtcp_net *peer, unsigned char command, unsigned char label, unsigned char step,
                     unsigned char proc,unsigned char exch_key,
                     unsigned char subf, unsigned char subf_dep,
                     unsigned char status, unsigned char *data, int size);
int dtcp_ip_ake_recv(dtcp_net *peer, unsigned char *label, unsigned char *step,
                     unsigned char *proc,unsigned char *exch_key,
                     unsigned char *subf, unsigned char *subf_dep,
                     unsigned char *status, unsigned char *ctype, unsigned char *data,int *size,
                     int tmout);
int dtcp_ip_get_peer_info(dtcp_net *peer, int *socket, int *port, int *address);



#endif
