/*-----------------------------------------------------------------------
//
// Proprietary Information of Elliptic Technologies
// Copyright (C) 2001-2012, all rights reserved
// Elliptic Technologies, Inc.
//
// As part of our confidentiality  agreement, Elliptic Technologies and
// the Company, as  a  Receiving Party, of  this  information  agrees to
// keep strictly  confidential  all Proprietary Information  so received
// from Elliptic Technologies. Such Proprietary Information can be used
// solely for  the  purpose  of evaluating  and/or conducting a proposed
// business  relationship  or  transaction  between  the  parties.  Each
// Party  agrees  that  any  and  all  Proprietary  Information  is  and
// shall remain confidential and the property of Elliptic Technologies.
// The  Company  may  not  use  any of  the  Proprietary  Information of
// Elliptic Technologies for any purpose other  than  the  above-stated
// purpose  without the prior written consent of Elliptic Technologies.
//
//-----------------------------------------------------------------------
//
// Project:
//
//   ELP - TOE
//
// Description:
//
//
// This file maps defines a system abstraction layer for some generic
// functions and data structures
//
//
//-----------------------------------------------------------------------
//
// Language:         C
//
//
// Filename:         $Source: /home/repository/cvsrep/dtcp_sdk/include/elpcrypto.h,v $
// Current Revision: $Revision: 1.30 $
// Last Updated:     $Date: 2012/01/23 21:39:14 $
// Current Tag:      $Name: DTCP-IP-SDK-V53-OFF-THE-SHELF-07-FEB-2012 $
//
//
//-----------------------------------------------------------------------*/


#ifndef _ELPCRYPTO_H_
#define _ELPCRYPTO_H_


#define ENCRYPT          0
#define DECRYPT          1

#define CRYPTO_MODE_AES_CBC   0x0001
#define CRYPTO_MODE_AES_ECB   0x0002
#define CRYPTO_MODE_AES_CCBC  0x0003
#define CRYPTO_MODE_AES_CTR   0x0004
#define CRYPTO_MODE_AES_FUSE  0x0005
#define CRYPTO_MODE_M6_S56    0x0010
#define CRYPTO_MODE_M6_KE56   0x0011
#define CRYPTO_MODE_M6_CCBC   0x0012
#define CRYPTO_MODE_HASH_SHA1 0x0020


#define CRYPTO_MODULE_AES     0x0001
#define CRYPTO_MODULE_M6      0x0004
#define CRYPTO_MODULE_HASH    0x0008
#define CRYPTO_MODULE_PRNG    0x0010

#define CRYPTO_AES_MIN_BLOCK_SIZE   16
#define CRYPTO_M6_MIN_BLOCK_SIZE    8
#define CRYPTO_HASH_MIN_BLOCK_SIZE  1
#define CRYPTO_HASH_SHA1_SIZE       20
#define CRYPTO_HASH_MD5_SIZE        16


int sha1_memory(U8 *in, int inlen, U8 *out, int *outlen);
int crypto_m6_mem(int mode, int decrypt, U8 *input, U8 *output, int size, U8 *key, int ksz);
int crypto_aes_ecb(int decrypt, U8 *input, U8 *output, int size, U8 *key, int ksz);
int crypto_aes_cbc( int decrypt, U8 *input, U8 *output, int size, U8 *iv, U8 *key, int ksz);
int crypto_aes_cbc_ex( int decrypt, U8 *input, U8 *output, int size, U8 *iv, U8 *key, int ksz, elpsymmetric_cbc *cbc);


#endif
