/*-----------------------------------------------------------------------
//
// Proprietary Information of Elliptic Technologies
// Copyright (C) 2001-2011, all rights reserved
// Elliptic Technologies, Inc.
//
// As part of our confidentiality  agreement, Elliptic Technologies and
// the Company, as  a  Receiving Party, of  this  information  agrees to
// keep strictly  confidential  all Proprietary Information  so received
// from Elliptic Technologies. Such Proprietary Information can be used
// solely for  the  purpose  of evaluating  and/or conducting a proposed
// business  relationship  or  transaction  between  the  parties.  Each
// Party  agrees  that  any  and  all  Proprietary  Information  is  and
// shall remain confidential and the property of Elliptic Technologies.
// The  Company  may  not  use  any of  the  Proprietary  Information of
// Elliptic Technologies for any purpose other  than  the  above-stated
// purpose  without the prior written consent of Elliptic Technologies.
//
//-----------------------------------------------------------------------
//
// Project:
//
//   ELP - TOE
//
// Description:
//
//
// This file maps defines a system abstraction layer for some generic
// functions and data structures
//
//
//-----------------------------------------------------------------------
//
// Language:         C
//
//
// Filename:         $Source: /home/repository/cvsrep/dtcp_sdk/include/elputils.h,v $
// Current Revision: $Revision: 1.28 $
// Last Updated:     $Date: 2011/11/04 17:14:33 $
// Current Tag:      $Name: DTCP-IP-SDK-V53-OFF-THE-SHELF-07-FEB-2012 $
//
//
//-----------------------------------------------------------------------*/


#ifndef _ELPUTILS_H_
#define _ELPUTILS_H_
#include "elptypes.h"
#ifdef ELPPERF
#include <elpperf.h>
#endif

#define htonl_e(x) \
( \
  ((U32)( \
    (((U32)((U32)(x)) & (U32)0x0000ffffUL) << 16) | \
    (((U32)((U32)(x)) & (U32)0xffff0000UL) >> 16) )) \
)

int   get_last_error(void);
U8    *inetaddr( U32 sa );
U16   dumphex(U8 *out,U8 *mem, S32 size, U8 *msg);
void  dumpword_ex(U32 *mem, S32 size, U8 *msg,S16 col,S16 bige);
void  dumpword(U32 *from, S32 size, U8 *msg,S16 bige);
void  dumpmem(U8 *mem, S32 size, U8 *msg,U32 bige);
void  memcpy8r(U8 *dst, U8 *src, S32 len);
void  memcpy8(U8 *dst, U8 *src, S32 len);
void  memset8(U8 *dst, U8 val,  S32 len);
void  memcpy32htonl(U32 *dst, U32 *src, S32 len);
void  memcpy32(U32 *dst, U32 *src, S32 len);
void  memcpy32htonl_r(U32 *dst, U32 *src, S32 len);
void  memcpy32_e(U32 *dst, U32 *src, S32 len);
void  memcpy32_re(U32 *dst, U32 *src, S32 len);
void  memcpy32_r(U32 *dst, U32 *src, S32 len);
void  memset32(U32 *dst, U32 val, S32 len);
void  memxor8 (U8 * dst, U8 * src, S32 len);
void  memsum8 (U8 * dst, U8 * src, S32 len);
S16   wcopy(U32 *src, U32 *dst, S32 size);
S16   wcopyton(U32 *src, U32 *dst, S32 size);
S16   wcmp(U32 *src, U32 *dst, S32 size);
S16   bytecmp(U8 *src, U8 *dst, S32 size);

#define DUMPWORD(m,t,z,f)       dumpword((U32 *)(m),(S16)(t),(U8*)(z),(f))
#define DUMPWORD_(m,t,z,f)
#define MEMCMP8(s1,s2,z)        bytecmp((U8*)(s1),(U8*)(s2),(S32)(z))
#define MEMSUM8(d,s,z)          memsum8((U8*)(d),(U8*)(s),(S32)(z))
#define MEMXOR8(d,s,z)          memxor8((U8*)(d),(U8*)(s),(S32)(z))
#define MEMCPYR(d,s,z)          memcpy8r((U8*)(d),(U8*)(s),(S32)(z))
#define MEMCPY(d,s,z)           memcpy((char*)(d),(char*)(s),(size_t)(z))
//#define MEMCPY(d,s,z)           memcpy8((U8*)(d),(U8*)(s),(S32)(z))
#define MEMCPY32(d,s,z)         memcpy32((U32 *)(d),(U32 *)(s),(S32)(z))
#define MEMCPY32_E(d,s,z)       memcpy32_e((U32 *)(d),(U32 *)(s),(z))
#define MEMCPY32_R(d,s,z)       memcpy32_r((U32 *)(d),(U32 *)(s),(z))
#define MEMCPY32HTONL(d,s,z)    memcpy32htonl((U32 *)(d),(U32 *)(s),(S32)(z))
#define MEMCPY32HTONL_R(d,s,z)  memcpy32htonl_r((U32 *)(d),(U32 *)(s),(z))
#define MEMCPY32_RE(d,s,z)      memcpy32_re((U32 *)(d),(U32 *)(s),(z))
#define MEMSET32(d,v,z)         memset32((U32 *)(d),(U32)(v),(S32)(z))
#define MEMSET(d,v,z)           memset8((U8 *)(d),(U8)(v),(S32)(z))
#define BTOW(i)                 ((((i)?(i):-3)-1)/4+1)

#ifdef WIN32

typedef HANDLE pthread_t;
typedef unsigned int pthread_attr_t;
int pthread_create(pthread_t *thread, const pthread_attr_t *attr, void *func(void *), void *arg);
int pthread_join(pthread_t thread, void **value_ptr);

#pragma message ( "USLEEP translated to SLEEP (in milliseconds)" )

typedef unsigned int useconds_t;
int usleep(useconds_t useconds);

#define sleep Sleep

#if defined(_MSC_VER) || defined(_MSC_EXTENSIONS)
  #define DELTA_EPOCH_USEC  11644473600000000Ui64
#else
  #define DELTA_EPOCH_USEC  11644473600000000ULL
#endif


int gettimeofday(struct timeval *tv, struct timezone *tz);

#define ctime_r(x,y) strcpy(y,ctime(x))

#endif

#endif
