#!/bin/bash
#$1 - "path/to/version.info" (input/output file name)
#$2 - application/image name which you want to show up in version.info
#$3 - checkout folder name

if [ $# -lt 3 ]; then
	echo "Usage: $0 <path/to/target/version.info> <filename> <path/to/svn/checkout/folder"
	echo "In version.ino you will get following output (this is just an example)"
	echo " cavium_dvu.bin			r644			http://crisp/sdk/cnc1900"
	exit 1;
fi;

SVN_VER=$(svnversion $3)
#SVN_VER="$(svn info $3 | grep "^Last Changed Rev:" | cut -c 19-)"

SVN_PATH="$(svn info $3 | grep "^URL:" | cut -c 6-)"
p=$3
FileOrFolderName=$( echo ${p##*/})
sed "/$2/d" -i $1
#echo -e "$2\t\t\tr$SVN_VER\t\t\t$SVN_PATH" >> $1
printf '%-40s r%-10s %-50s\n' "$2" "$SVN_VER" "$SVN_PATH" >>$1

