#!/bin/bash

RM="rm -rf"

set -e

check_ffmpeg() {
	cat $CRISP_RELEASE/buildroot/package/multimedia/ffmpeg/*.patch | md5sum - > $TAG_DIR/.ffmpeg_check_new
	[ -f $TAG_DIR/.ffmpeg_check ] && ( cmp -s $TAG_DIR/.ffmpeg_check{,_new} || $RM $BR_DIR/build/ffmpeg* )
	mv $TAG_DIR/.ffmpeg_check{_new,}
}

check_directfb() {
	cat $CRISP_RELEASE/buildroot/package/directfb/*.patch | md5sum - > $TAG_DIR/.directfb_check_new
	[ -f  $TAG_DIR/.directfb_check ] && ( cmp -s $TAG_DIR/.directfb_check{,_new} || $RM $BR_DIR/build/directfb* )
	mv $TAG_DIR/.directfb_check{_new,}
}

check_busybox() {
    cat $CNC_PLATFORM/configs/busybox_config | md5sum - > $TAG_DIR/.busybox_check_new
    [ -f $TAG_DIR/.busybox_check ] && ( cmp -s $TAG_DIR/.busybox_check{,_new} || $RM $BR_DIR/build/busybox* )
    mv $TAG_DIR/.busybox_check{_new,}
}

check_libupnp() {
	cat $CRISP_RELEASE/buildroot/package/libupnp/*.patch | md5sum - > $TAG_DIR/.libupnp_check_new
	[ -f $TAG_DIR/.libupnp_check ] && ( cmp -s $TAG_DIR/.libupnp_check{,_new} || $RM $BR_DIR/build/libupnp* )
	mv $TAG_DIR/.libupnp_check{_new,}
}

if [ $# -lt 3 ]; then
    echo "Usage: $0 buildroot_dir tag_dir packages"
    exit 1
fi

BR_DIR=$1
TAG_DIR=$2

shift
shift

while [ "$*" != "" ]
do
    case "$1" in
        ffmpeg)
            check_ffmpeg
        ;;
        
        busybox)
            check_busybox
        ;;
        
        libupnp)
            check_libupnp
            ;;
        
        directfb)
            check_directfb
            ;;
        
        *)
            echo "Package not processed $1"
    esac
    shift
done
