#!/bin/bash
#
# To call this script, make sure make_ext4fs is somewhere in PATH

function usage() {
cat<<EOT
Usage:
mkext4.sh SRC_DIR OUTPUT_FILE SIZE
EOT
}

MYDIR=$(dirname $0)

if [ $# -ne 2 -a $# -ne 3 ]; then
  usage
  exit 1
fi

SRC_DIR=$1
if [ ! -d $SRC_DIR ]; then
  echo "Can not find directory $SRC_DIR!"
  exit 2
fi

OUTPUT_FILE=$2
SIZE=$3

if [ -z $SIZE ]; then
    SIZE=32M
fi

MAKE_EXT4FS_CMD="$MYDIR/make_ext4fs -l $SIZE $OUTPUT_FILE $SRC_DIR"
echo $MAKE_EXT4FS_CMD
$MAKE_EXT4FS_CMD
if [ $? -ne 0 ]; then
  exit 4
fi
