#!/bin/bash
# Author: xiaodong.fan@celestialsemi.cn
#Compute the size of file system
ROOTFS_TARGET=../../rootfs
FIRMWARE_SRC=../firmware
FIRMWARE_DES=$ROOTFS_TARGET/lib/firmware
FW_DIR=`ls ${FIRMWARE_SRC} ` 


EXT2FS_BIN=${CRISP_RELEASE}/tools/bin/genext2fs
FILENAME_ORG=rootfs.ext2
OUTPUT_ORG=ramdisk.img
generate_ramdisk()
{
    size=`du -s --apparent-size $ROOTFS_TARGET | cut --fields=1`
    size=`expr '(' '(' $size / 1024 ')' + 2 ')' '*' 1024 `
    if [ $size -ge 20000 ];
    then
		size=$(expr $size + 16384)
    else
		size=$(expr $size + 2400)
    fi    
    echo 'rootfs size='$size
    
# Create an loop device to create an ext2 file system on it
# Form a proper file name with date, size along with Project name (passed as command parameter).

    
    inode_counti=`expr '(' $size / 4 ')'`
    
#genext2fs -b $size -N $inode_count -d /target-minimal $filename

    $EXT2FS_BIN -b $size -m 0 -N $inode_counti -d $ROOTFS_TARGET $FILENAME
    echo
    echo 'Compressing .......'
    echo
    
# Use best compression for file.
    gzip -v9 $FILENAME
    echo
    echo
    echo '*****************************************'
    echo 'Generated - ' $FILENAME'.gz'
    echo 'Use this value to specify the Ramdisk size in Board configuration utility'
    echo '*****************************************'
    echo
    echo '*****************************************'
    echo 'Generated - ramdisk from ' $FILENAME'.gz'
    echo '*****************************************'
    ${CRISP_RELEASE}/tools/bin/mkimage -A arm -O linux -T ramdisk -C gzip -a 0x02500000 -e 0x02500000 -n "ARM Linux RAMDisk" -d $FILENAME'.gz'  $OUTPUT
    rm *.gz
}

if test -d $ROOTFS_TARGET; then

	if test ! -d $FIRMWARE_DES; then
		mkdir $FIRMWARE_DES
	fi
	
    if test -d $FIRMWARE_SRC && test -d $FIRMWARE_DES; then
        for arg in $FW_DIR 
          do
          echo "Generating Ramdisk for $arg"
          rm -f $FIRMWARE_DES/*
          cp -f $FIRMWARE_SRC/$arg/* $FIRMWARE_DES
          OUTPUT=${OUTPUT_ORG}_for_$arg
          FILENAME=$FILENAME_ORG
          generate_ramdisk

        done
    else
        OUTPUT=${OUTPUT_ORG}
        FILENAME=$FILENAME_ORG

        generate_ramdisk
    fi

fi
