#####################################################################################################
#SET(CMAKE_BUILD_TYPE Debug)
SET(CMAKE_BUILD_TYPE Release)
#####################################################################################################
IF (NOT $ENV{CNC_ARCH} STREQUAL "")
  SET(CNC_ARCH "$ENV{CNC_ARCH}")
ELSE (NOT $ENV{CNC_ARCH} STREQUAL "")
  SET(CNC_ARCH "CNC1800L")
ENDIF (NOT $ENV{CNC_ARCH} STREQUAL "")
MESSAGE(STATUS "CNC_ARCH = ${CNC_ARCH}")
#####################################################################################################
IF (${CNC_ARCH} STREQUAL "CNC1800L")
    ADD_DEFINITIONS(-DARCH_CSM1800L)
    SET(CRISP_CROSS_PRE "arm-none-linux-gnueabi-")
    SET(CRISP_BASE_LIBS csapi)
ENDIF (${CNC_ARCH} STREQUAL "CNC1800L")
#####################################################################################################
IF (${CNC_ARCH} STREQUAL "CNC1800H")
    ADD_DEFINITIONS(-DARCH_CSM1800H)
    SET(CRISP_CROSS_PRE "arm-none-linux-gnueabi-")
    SET(CRISP_BASE_LIBS csapi)
ENDIF (${CNC_ARCH} STREQUAL "CNC1800H")
#####################################################################################################
IF (${CNC_ARCH} STREQUAL "CNC1900")
    ADD_DEFINITIONS(-DARCH_CSM1900)
    SET(CRISP_CROSS_PRE "arm-linux-gnueabihf-")
    SET(CRISP_BASE_LIBS csapi GAL directfb direct fusion)
    LINK_DIRECTORIES(${CRISP_RELEASE}/thirdparty/cnc1900/2d/lib)
    LINK_DIRECTORIES(${CRISP_STAGING}/usr/lib)
ENDIF (${CNC_ARCH} STREQUAL "CNC1900")
#####################################################################################################
MESSAGE(STATUS "CRISP_CROSS_PRE = ${CRISP_CROSS_PRE}")
#####################################################################################################
SET(CMAKE_AR ${CRISP_CROSS_PRE}ar)
SET(CMAKE_CXX_COMPILER ${CRISP_CROSS_PRE}g++)
SET(CMAKE_C_COMPILER ${CRISP_CROSS_PRE}gcc)
SET(CMAKE_LINKER ${CRISP_CROSS_PRE}ld)
SET(CMAKE_NM ${CRISP_CROSS_PRE}nm)
SET(CMAKE_OBJCOPY ${CRISP_CROSS_PRE}objcopy)
SET(CMAKE_OBJDUMP ${CRISP_CROSS_PRE}objdump)
SET(CMAKE_RANLIB ${CRISP_CROSS_PRE}ranlib)
SET(CMAKE_STRIP ${CRISP_CROSS_PRE}strip)
#####################################################################################################
IF (EXISTS ${CRISP_STAGING})
    SET(SYSROOT "--sysroot ${CRISP_STAGING}")
ELSE (EXISTS ${CRISP_STAGING})
    MESSAGE(ERROR "CRISP_STAGING is undefined")
    SET(SYSROOT "")
ENDIF (EXISTS ${CRISP_STAGING})
MESSAGE(STATUS "CRISP_STAGING = ${CRISP_STAGING}")
#####################################################################################################
IF (CNC_ARCH STREQUAL "CNC1900")
SET(DEFAULT_COMPILE_FLAGS "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -mcpu=cortex-a9 -mfpu=vfpv3-d16 -mfloat-abi=hard -pipe -W -O2 ${SYSROOT}")
SET(CMAKE_C_FLAGS_DEBUG "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -mcpu=cortex-a9 -mfpu=vfpv3-d16  -mfloat-abi=hard -pipe -W -O0 -g ${SYSROOT}")
SET(CMAKE_C_FLAGS_RELEASE "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -mcpu=cortex-a9 -mfpu=vfpv3-d16  -mfloat-abi=hard -pipe -W -O2 ${SYSROOT}")
SET(CMAKE_CXX_FLAGS_DEBUG "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -mcpu=cortex-a9 -mfpu=vfpv3-d16  -mfloat-abi=hard -pipe -W -O0 -g ${SYSROOT}")
SET(CMAKE_CXX_FLAGS_RELEASE "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -mcpu=cortex-a9 -mfpu=vfpv3-d16  -mfloat-abi=hard -pipe -W -O2 ${SYSROOT}")
ENDIF (CNC_ARCH STREQUAL "CNC1900")
#####################################################################################################
IF (CNC_ARCH STREQUAL "CNC1800L")
SET(DEFAULT_COMPILE_FLAGS "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -mtune=arm1176jzf-s -march=armv6zk -mabi=aapcs-linux -pipe -W -O2  ${SYSROOT}")
SET(CMAKE_C_FLAGS_DEBUG "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -mtune=arm1176jzf-s -march=armv6zk -mabi=aapcs-linux -pipe -W -O0 -g ${SYSROOT}")
SET(CMAKE_C_FLAGS_RELEASE "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -mtune=arm1176jzf-s -march=armv6zk -mabi=aapcs-linux -pipe -W -O2 ${SYSROOT}")
SET(CMAKE_CXX_FLAGS_DEBUG "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -mtune=arm1176jzf-s -march=armv6zk -mabi=aapcs-linux -pipe -W -O0 -g ${SYSROOT}")
SET(CMAKE_CXX_FLAGS_RELEASE "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -mtune=arm1176jzf-s -march=armv6zk -mabi=aapcs-linux -pipe -W -O2 ${SYSROOT}")
#####################################################################################################
ENDIF (CNC_ARCH STREQUAL "CNC1800L")
IF (CNC_ARCH STREQUAL "CNC1800H")
SET(DEFAULT_COMPILE_FLAGS "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -march=armv5te -W ")
SET(CMAKE_C_FLAGS_DEBUG "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -march=armv5te -W -Wextra -msoft-float -O0 -g  ${SYSROOT}")
SET(CMAKE_C_FLAGS_RELEASE "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -march=armv5te -W -msoft-float -ffast-math -Os ${SYSROOT}") 
SET(CMAKE_CXX_FLAGS_DEBUG "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -march=armv5te -W -O0 -g  ${SYSROOT}")
SET(CMAKE_CXX_FLAGS_RELEASE "-D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -march=armv5te -W -O2  ${SYSROOT}")
ENDIF (CNC_ARCH STREQUAL "CNC1800H")
#####################################################################################################
#ADD_DEFINITIONS("-Wall -Wextra")
ADD_DEFINITIONS("-Wpointer-arith")
ADD_DEFINITIONS("-Winline -Wundef")
ADD_DEFINITIONS("-Wno-unused-function -Wno-unused-parameter -Wno-unused-variable -Wno-cast-qual")
ADD_DEFINITIONS("-Wno-ignored-qualifiers -Wno-attributes")
ADD_DEFINITIONS("-Wno-undef -Wno-sign-conversion -Wno-sign-compare")
ADD_DEFINITIONS("-Wno-builtin-macro-redefined")
set(CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS} "-Wno-enum-compare") 
#####################################################################################################
