LOG='logger -p 2 -t StartApps.sh --'
LOGINFO='logger -p 6 -t StartApps.sh --'

#####################################################################################################################
# WIFI START
#####################################################################################################################

$LOGINFO "STA=${STA}, AP=${AP}, P2P=${P2P}, WFD=${WFD}, NETWORK=${NETWORK}"

ln -sf /proc/netHD_config /config
ln -sf /sys/module/PureVu/parameters /params

#####################################################################################################################
# Launch the app
#####################################################################################################################

if [ "$DEV_TYPE" = "TX" ] ; then
    AUXDEV="TX"
    AUXAPP="/usr/bin/cnc_media_wdtx_app"
    # Specific WIFI parameters
    APP_ARGS=" --ap --ap-ssid $AP_SSID --ap-channel $AP_CHANNEL"
elif [ "$DEV_TYPE" = "RX" ] ; then
    AUXDEV="RX"
    AUXAPP="/usr/bin/cnc_wivu_rx"
    # Specific WIFI parameters
    APP_ARGS=" --wivu --sta"
elif [ "$DEV_TYPE" = "MII_TX" ] ; then
    AUXDEV="TX"
    AUXAPP="/usr/bin/cnc_media_wdtx_app"
    # Specific ethernet params
    APP_ARGS=" --eth --wivu-group 2222"
elif [ "$DEV_TYPE" = "MII_RX" ] ; then
    AUXDEV="RX"
    AUXAPP="/usr/bin/cnc_wivu_rx"
    # Specific ethernet params
    APP_ARGS=" --eth --wivu-group 2222"
elif [ "$DEV_TYPE" = "MII_AUTO" ] ; then
    AUXDEV=""
    AUXAPP=""
    APP_ARGS=""
    echo MII_AUTO not supported yet
else
    AUXDEV=""
    AUXAPP=""
    APP_ARGS="Unknwon DEV_TYPE='$DEV_TYPE' Not Launching anything"
fi

if [ "$IP_ADDRESS" != "" ] ; then
    APP_ARGS="$APP_ARGS --ip-address $IP_ADDRESS"
fi

if [ "$NETMASK" != "" ] ; then
    APP_ARGS="$APP_ARGS --netmask $NETMASK"
fi

if [ "$AUXDEV" = "TX" ] ; then
    if [ "$BITRATE" != "" ] ; then
        APP_ARGS="$APP_ARGS --bitrate-kbps $BITRATE"
    fi
elif [ "$AUXDEV" = "RX" ] ; then
    if [ "$DECODER_DEBUG" != "" ] ; then
        APP_ARGS="$APP_ARGS --debugMask $DECODER_DEBUG"
    fi
    if [ "$DECODER_LATENCY" != "" ] ; then
        APP_ARGS="$APP_ARGS --decoderLatency $DECODER_LATENCY"
    fi
    if [ "$AVSYNC" != "" ] ; then
        APP_ARGS="$APP_ARGS --avSync $AVSYNC"
    fi
fi

$LOGINFO "Launching $AUXAPP $APP_ARGS"
if [ "$AUXAPP" != "" ] ; then
    $AUXAPP $APP_ARGS > /dev/console &
fi
