#!/bin/sh
# This changes the device_name or friendly name in the p2p.conf or adapter.config.default

# Supported interface names : ar9374( p2p0, wlan0 ), ar6203( p2p0 wlan0 )
# GUI uses wlan0's last 2 bytes of mac address as Dongle's display name,
# and not all the devices' last 2 bytes of wlan0 and p2p0 mac address are the same.
# So use wlan0's last 2 bytes of mac address in p2p.conf to keep sync with GUI.
MAC=`ifconfig wlan0 | grep "HWaddr " | awk '{print $5}' | sed -e s/://g`
SHORTMAC=${MAC:${MAC_SKIP_DIGITS}}

if [ $1 == "p2p" ] ; then
    serial_num_config=`fw_printenv -q SERIAL_NUMBER`
    if [ "$serial_num_config" == "" ] ; then
        sed -i "/serial_number=/ c serial_number=${MAC}" $2
    else
        sed -i "/serial_number=/ c serial_number=${serial_num_config}" $2
    fi

    sed -i 's/device_name=.*/&'"${SHORTMAC}"'/' $2
    sed -i 's/p2p_ssid_postfix=.*/&'"${SHORTMAC}"'/' $2
    sync
else
    if [ $1 == "adapter" ] ; then
        sed -i 's/friendly_name=.*/&'" ${SHORTMAC}"'/' $2
        sync
    fi
fi
