#!/bin/sh

LOG='logger -p 1 -t watchdog --'

if [ "$DISABLE_WATCHDOG" = "1" ] ; then
    echo "DISABLE_WATCHDOG is set. Exiting watchdog." | $LOG
    exit
fi

if [ "$DEV_TYPE" = "TX" ] ; then
    APP="cnc_media_wdtx_app"
elif [ "$DEV_TYPE" = "RX" ] ; then
	APP="cnc_wivu_rx"
elif [ "$DEV_TYPE" = "MII_TX" ] ; then
    APP="cnc_media_wdtx_app"
elif [ "$DEV_TYPE" = "MII_RX" ] ; then
	APP="cnc_wivu_rx"
elif [ "$DEV_TYPE" = "MII_AUTO" ] ; then
    echo "MII_AUTO not supported yet. Not Launching watchdog"
    exit
else
    echo "Unknown DEV_TYPE='$DEV_TYPE' Not Launching watchdog"
    exit 
fi
                
sleep 15
while [ 1 ] ; do
    if [ ! "$(pidof proxyforkd)" \
      -o ! "$(pidof $APP)" ] ; then
        $LOG "CRITICAL PROCESS DIED... rebooting"
        echo "CRITICAL PROCESS DIED... rebooting"
        ps | $LOG
        ps
        reboot
    fi
    sleep 5
done

